/************************************************************************/
/*                                                                      */
/* Defines file         for Jxx ARM Programming purposes (c) NiMar 2003 */
/*                                                                      */
/************************************************************************/
/* Portability Area                                                     */
/* put functions and other stuff addresses here to keep more portable   */
/* the code! For other fw, just change the equ to correct values!       */
/*                                                                      */
/* Last update 07.05.2003                                               */
/*    Complete address list for 3 firmwares:                            */
/*      J7/70 3.10/4   - NiMar                                          */
/*      J7/70 3.6/5    - NiMar, Bodhi3, SuperGoofy                      */
/*      J5/6  5.4.2/6  - Andrey, Keen                                   */
/*                                                                      */
/* update 06.05.2003                                                    */
/*    Corrected init random  - now work on all firmwares!               */
/*                                                                      */
/* USAGE:                                                               */
/*   Special defines in your source file:                               */
/*     .xdef UFIF - use UFIF functions, else - FW-dependent code        */
/*                                                                      */
/*   Target FW select for FW-dependent code                             */
/*     .equ J7_3.10_4,0  - J7/70 3.10/4                                 */
/*     .equ J7_3.6_5,0   - J7/70 3.6/5                                  */
/*     .equ J6_5.4.2_6,0 - J5/6  5.4.2/6                                */
/*                                                                      */
/* Feel free to add functions for your firmware - just send a copy to me*/
/* on nimar@mail.rb.ru                                                  */
/************************************************************************/
.ifdef UFIF
        .equ    UFIFvideoMem,       0x36ac74      /* Firmware-stored VideoMemory address */
        .equ    UFIFTimerAddr,      0x36aa84
        .equ    FreeMem,            0x801000
.else
.ifdef J7_3.10_4
     /*      J7/70 FW:3.10/4 Lib        */
     /* By NiMar                        */
     .equ    ver,            0x20031004

     /* Some Address in FW */
     .equ    wallAddr,       0x86a677        /* Current wallpaper address */
     .equ    mannerAddr,     0x865c00        /* Current manner address */
     .equ    askptAddr,      0x876164        /* *#ASKPT1x value adrress */
     .equ    IMSIAddr,       0x875A08
     .equ    videoMem,       0x0301BD2C      /* VideoMemory address */

     .equ    menuIconID,     0xE836
     .equ    TimerAddr,      0x0085E254

     .equ    TimeAddr,       0x008793c8 @ sec, min, hours
     .equ    DateAddr,       0x008793d4 @ day, month, year

     .equ    LightOffCounterAddr,0x0087a800 @ InitConstant, Counter
     .equ    LightOffFlag,       0x0087a804 @ 0 disable BLight CountDown
     .equ    UseBackLightAddr,   0x00864c50 @ (in Preferences)

     .equ    IdleCounterAddr,    0x0087a8f0 @ InitConstant, Counter

     /* Functions    */

     .equ    free_SG,                0x00A0AC9 /*SG's free*/
     .equ    LogPrintF_root,         0x018E825
.endif

.ifdef J7_3.6_5
        /*      J7/70 FW:3.6/5 Lib        */
        /* (it's all we know for this fw) */
        .equ    ver,            0x20036005

        /* Some Address in FW */
        .equ    wallAddr,       0x86a277        /* Current wallpaper address */
        .equ    mannerAddr,     0x865800        /* Current manner address */
        .equ    askptAddr,      0x875D64        /* *#ASKPT1x value adrress */
        .equ    videoMem,       0x0301BB90      /* VideoMemory address */

        /* some stuff used by PRG Loader 2 */
        .equ    menuIconID,     0xE836
        .equ    TimerAddr,      0x08302E8

        .equ    TimeAddr,       0x0087975c @ sec, min, hours   ????
        .equ    DateAddr,       0x00879768 @ day, month, year  ????

        .equ    LightOffCounterAddr,0x0087a330 @ InitConstant, Counter
        .equ    LightOffFlag,       0x0087a338 @ 0 disable BLight CountDown
        .equ    UseBackLightAddr,   0x00864850 @ (in Preferences)

        .equ    IdleCounterAddr,    0x0087A42C @ InitConstant, Counter

     /* Functions    */

     .equ    free_SG,                0x00a051d /*SG's free*/
     .equ    LogPrintF_root,         0x018e051
.endif

.ifdef J6_5.4.2_6
        .equ    ver,            0x20054206     @ 5.4.2/6

        /* Some Address in FW */
        .equ    wallAddr,       0x0085A82F        /* Current wallpaper address */
        .equ    mannerAddr,     0x865c00 @!!! Don`t rigth        /* Current manner address */
        .equ    askptAddr,      0x876164 @!!! Don`t rigth       /* *#ASKPT1x value adrress */
        .equ    videoMem,       0x0301B380      /* VideoMemory address */

        /* some stuff used by PRG Loader 2 */
        .equ    menuIconID,     0xE836
        .equ    TimerAddr,      0x084d990

        .equ    TimeAddr,       0x00868f44 @ sec, min, hours 
        .equ    DateAddr,       0x00868f50 @ day, month, year

        .equ    LightOffCounterAddr,0x0086a348 @ InitConstant, Counter
        .equ    LightOffFlag,       0x0086a34c @ 0 disable BLight CountDown
        .equ    UseBackLightAddr,   0x00853D34 @ (in Preferences)

        .equ    IdleCounterAddr,    0x0086a3c0 @ InitConstant, Counter
.endif

.endif
        

/************************************************************************/
/*                                                                      */
/* FW functions Libraries                                               */
/*                      for Jxx ARM Programming purposes (c) NiMar 2003 */
/*                                                                      */
/************************************************************************/
/*                                                                      */
/*  Usage: To use functions include .xdef <libname> string in your      */
/*         program                                                      */
/*                                                                      */
/*    <libname> can be:                                                 */
/*        DISPLAY   - display and backlight management functions        */
/*        MEMORY    - memory management functions                       */
/*        STRINGS   - strings functions                                 */
/*        NVM         NVM functions                                     */
/*        WINDOWS     windows functions                                 */
/*        TIMER       Menu Events functions                             */
/*        DEBUG       Monitor Mode function                             */
/*        RANDOM      DIV/MOD random                                    */
/*        GFX_MAIN    draw text, and fw gfx functions                   */
/*        GFX_SPRITE  sprites management functions                      */
/*        GFX         simple gfx primitives                             */
/*                                                                      */
/*                                                                      */
/*    Also you may use special include .xdef OOK2_2 string in your      */
/*         program whitch will mean use some function directly          */
/*         but this only for OOK2 2 firmware                            */
/*                                                                      */
/*                                             NiMar  nimar@mail.rb.ru  */
/************************************************************************/
.macro MyExternalFunc Name Address
.\Name:
.align 2
  push  {r0-r1}
  ldr   r0,_\Name
  str   r0,[sp,#4]
  pop   {r0,pc}
_\Name:
    .word \Address
.endm


/************************************************************************/
/* FW dislpay management functions                                      */
/************************************************************************/
.ifdef DISPLAY

.ifdef UFIF
        MyExternalFunc DisplayRefresh       0x036A659
        MyExternalFunc repaint              0x036A689
        MyExternalFunc TurnLight            0x036A67D
        MyExternalFunc TurnLight_if_Enabled 0x036a695

.else

.ifdef J7_3.10_4
MyExternalFunc DisplayRefresh 0x00CB38D
MyExternalFunc BackLightOff   0x024963F @ 
MyExternalFunc BackLightOn    0x024964F @ 
MyExternalFunc TurnLight      0x0249665 @ 0 - turn off forever 1 - enable and turn on
.endif

.ifdef J7_3.6_5
MyExternalFunc DisplayRefresh 0x00CADE5
MyExternalFunc BackLightOff   0x0269EE7 @ 
MyExternalFunc BackLightOn    0x0269ef7 @ 
MyExternalFunc TurnLight      0x0269f0d @ 0 - turn off forever 1 - enable and turn on
.endif

.ifdef J6_5.4.2_6
MyExternalFunc DisplayRefresh 0x0301D633
MyExternalFunc BackLightOff   0x00269EE7
MyExternalFunc BackLightOn    0x00269EF7
MyExternalFunc TurnLight      0x00269F0d
.endif

.align 2
.repaint:
  push {LR}
  mov  r0,#0
  bl    .DisplayRefresh
  pop  {PC}

.align 2
.TurnLight_if_Enabled:
  push {r1, LR}
        LDR     R1, UAddr
        LDR     R1, [R1]
        LSR     R1, R1, #0x14
        BCC     no_turn
        BL      .TurnLight
  no_turn:
  pop  {r1, PC}
UAddr: .word UseBackLightAddr

.endif
.endif

/************************************************************************/
/* FW memory management functions                                       */
/************************************************************************/
.ifdef MEMORY
.ifdef UFIF
        MyExternalFunc memset 0x036a6e9
        MyExternalFunc malloc 0x036a6f5
        MyExternalFunc free   0x036a701
        MyExternalFunc memcpy 0x036a70d
.else
.ifdef J7_3.10_4
MyExternalFunc memset 0x01D6B87
MyExternalFunc malloc 0x024A9AD
MyExternalFunc free   0x00A0AC9
MyExternalFunc memcpy 0x0011079
.endif

.ifdef J7_3.6_5
MyExternalFunc memset 0x01D5F4F
MyExternalFunc malloc 0x0249B7D
MyExternalFunc free   0x00a051d
MyExternalFunc memcpy 0x0011079
.endif

.ifdef J6_5.4.2_6
MyExternalFunc memset 0x001F3207
MyExternalFunc malloc 0x0026B4CD
MyExternalFunc free   0x000C7E59
MyExternalFunc memcpy 0x0026DFED
.endif
.endif
.endif

/************************************************************************/
/* FW strings functions                                                 */
/************************************************************************/
.ifdef STRINGS
.ifdef UFIF
        .WString_MakeFromAscii:
        MyExternalFunc WStr_MakeFA  0x036a719
        .WString_Destroy:
        MyExternalFunc WStr_Destroy 0x036a725
        MyExternalFunc IntToWStr    0x036a731
        MyExternalFunc sprintf      0x036a73d  @ !!!!!!!!!!!!!!
.else
.ifdef J7_3.10_4
.WString_MakeFromAscii:
MyExternalFunc WStr_MakeFA  0x005ADF9
.WString_Destroy:
MyExternalFunc WStr_Destroy 0x005AEF1
MyExternalFunc IntToWStr    0x01F4339
MyExternalFunc sprintf      0x018E72B
.endif

.ifdef J7_3.6_5
.WString_MakeFromAscii:
MyExternalFunc WStr_MakeFA  0x005AB91
.WString_Destroy:
MyExternalFunc WStr_Destroy 0x005AC89
MyExternalFunc IntToWStr    0x01f36ed
MyExternalFunc sprintf      0x018DF57
.endif

.ifdef J6_5.4.2_6
.WString_MakeFromAscii:       
MyExternalFunc WStr_MakeFA  0x0005C429
.WString_Destroy:             
MyExternalFunc WStr_Destroy 0x0005C521
MyExternalFunc IntToWStr    0x00210895
MyExternalFunc sprintf      0x001AFE97
.endif
.endif
.endif

/************************************************************************/
/* FW NVM functions                                                     */
/************************************************************************/
.ifdef NVM
.ifdef UFIF
        MyExternalFunc NVMGetSection     0x036a749
        MyExternalFunc NVMReadSection    0x036a755
        MyExternalFunc NVMCloseSection   0x036a761
        MyExternalFunc NVMWriteSection   0x036a76d
        MyExternalFunc NVMEraseSection   0x036a779
        MyExternalFunc NVMGetSectionSize 0x036a785
        MyExternalFunc NVMSeekSection    0x036adcd
        MyExternalFunc NVMAttrSection    0x036add9
.else
.ifdef J7_3.10_4
MyExternalFunc NVMGetSection     0x00FCDC1
MyExternalFunc NVMReadSection    0x00FD1FB
MyExternalFunc NVMCloseSection   0x00FCFA1
MyExternalFunc NVMWriteSection   0x00FD345
MyExternalFunc NVMEraseSection   0x00FD019
MyExternalFunc NVMGetSectionSize 0x00FD71D
MyExternalFunc NVMSeekSection    0x00FD648
MyExternalFunc NVMAttrSection    0x00FD779
.endif

.ifdef J7_3.6_5
MyExternalFunc NVMGetSection     0x00F5B09
MyExternalFunc NVMReadSection    0x00F5F47
MyExternalFunc NVMCloseSection   0x00F5CE9
MyExternalFunc NVMWriteSection   0x00f60b5
MyExternalFunc NVMEraseSection   0x00F5D60
MyExternalFunc NVMGetSectionSize 0x00F64B9
MyExternalFunc NVMSeekSection    0x00F63E5
MyExternalFunc NVMAttrSection    0x00F6519
.endif

.ifdef J6_5.4.2_6
MyExternalFunc NVMGetSection     0x01188DD
MyExternalFunc NVMReadSection    0x0118D1B
MyExternalFunc NVMCloseSection   0x0118ABD
MyExternalFunc NVMWriteSection   0x0118E89
MyExternalFunc NVMEraseSection   0x0118B35
MyExternalFunc NVMGetSectionSize 0x011928D
MyExternalFunc NVMSeekSection    0x011949b
MyExternalFunc NVMAttrSection    0x01192Ed
.endif
.endif
.endif

/************************************************************************/
/* FW windows functions                                                 */
/*    Uses:                                                             */
/*         strings functions                                            */
/*         memory  functions                                            */
/************************************************************************/
.ifdef WINDOWS
.ifdef UFIF
        MyExternalFunc GetWindowManager      0x036a791     @ some address J5 0x86A4F4 -> J7 0x87AB24
        .GetWindowById:
        MyExternalFunc GetWindowHandle       0x036a79d
        .cWindowWidget_Create:
        MyExternalFunc WindowWidget_Create   0x036a7a9
        MyExternalFunc WindowWidget_Destroy  0x036AE09
        MyExternalFunc CloseWindow           0x036a7b5
        MyExternalFunc WindowWidget_KeyEvent 0x036a7c1
        MyExternalFunc WindowWidget_SetTimer 0x036a7d9
        MyExternalFunc WindowRepaint         0x036a7fd

        MyExternalFunc InfoBoxOld            0x036A819
        MyExternalFunc InfoBoxNew            0x036A869
.else
.ifdef J7_3.10_4
MyExternalFunc GetWindowManager      0x001f544b     @ some address J5 0x86A4F4 -> J7 0x87AB24
.GetWindowById:
MyExternalFunc GetWindowHandle       0x018AD41
.cWindowWidget_Create:
MyExternalFunc WindowWidget_Create   0x0018cded
MyExternalFunc CloseWindow           0x18AAF3
MyExternalFunc WindowWidget_KeyEvent 0x18D18D
MyExternalFunc MessageWindow         0x00E81F1
MyExternalFunc WindowWidget_SetTimer 0x018D025
MyExternalFunc CreateMonitorWindow   0x023BEAD
MyExternalFunc MonWND_AddLine        0x01CA0C7
MyExternalFunc WindowRepaint         0x001FC54D 
MyExternalFunc WindowWidget_Destroy  0x018d301
.endif

.ifdef J7_3.6_5
MyExternalFunc GetWindowManager      0x01f47ff  
.GetWindowById:
MyExternalFunc GetWindowHandle       0x018A56D
.cWindowWidget_Create:
MyExternalFunc WindowWidget_Create   0x018c619 
MyExternalFunc CloseWindow           0x018a31f
MyExternalFunc WindowWidget_KeyEvent 0x018c9b9
MyExternalFunc MessageWindow         0x00E6401
MyExternalFunc WindowWidget_SetTimer 0x018C851
MyExternalFunc CreateMonitorWindow   0x01C86AB
MyExternalFunc MonWND_AddLine        0x01C86AB
MyExternalFunc WindowRepaint         0x01FB3F9 
MyExternalFunc WindowWidget_Destroy  0x018cb2d
.endif

.ifdef J6_5.4.2_6
MyExternalFunc GetWindowManager      0x00211453
.GetWindowById:                        
MyExternalFunc GetWindowHandle       0x001A16AD
.cWindowWidget_Create:                 
MyExternalFunc WindowWidget_Create   0x001B0489
MyExternalFunc CloseWindow           0x001A13C9
MyExternalFunc WindowWidget_KeyEvent 0x001B0825
MyExternalFunc MessageWindow         0x00107E01
MyExternalFunc WindowWidget_SetTimer 0x001B06C1
MyExternalFunc CreateMonitorWindow   0x0025AE25
MyExternalFunc MonWND_AddLine        0x001E6EDb
MyExternalFunc WindowRepaint         0x00219011
MyExternalFunc WindowWidget_Destroy 0x01B0981
.endif

/***************************************************************************/
/* WNDsetpos (object,x,y) - Set top left corner position of any widget obj.*/
/***************************************************************************/
.align 2
.WNDsetpos: push      {lr}  /* r0 = obj  r1 = X  r2 = Y  */
            strh      r1,[r0,#0x4]
            strh      r2,[r0,#0x6]
            pop       {pc}

/***************************************************************************/
/* WNDsetsize (object,width,height) - Set any widget object size           */
/***************************************************************************/
.align 2
.WNDsetsize: push      {lr}  /* r0 = obj  r1 = width  r2 = height  */
             strh      r1,[r0,#0x8]
             strh      r2,[r0,#0xA]
             pop       {pc}
   /********************************************************/
   /* InfoBox(handle,text,time,type)                       */
   /*   handle=Parent WND handle                           */
   /*   text=ASCII null-terminated text (\n for new line)  */
   /*   time=Time to live in ms (0=no timer)               */
   /*   type=Type of dialog (0,3,4,5,6,7)                  */
   /********************************************************/
.align 2
.InfoBoxOld:
        push    {r3-r7,LR}
        sub     sp,sp,#0x14
        str     r0,[sp]
        str     r1,[sp,#4]
        str     r2,[sp,#8]
        mov     r5,r3

        mov     r0,#0x68
        bl      .malloc
        mov     r6,r0

        add     r0,sp,#0xC
        ldr     r1,[sp,#4]
        mov     r2,#2
        bl      .WString_MakeFromAscii
        mov     R7, R0
       
        mov     r0,r6
        ldr     r1,[sp]
        add     r2,sp,#0xC
        mov     r3,r5

        push    {r7}
        STR     R7, [SP]
        MOV     R4, #1
        MOV     R7, SP
        STRB    R4, [R7,#4]
        bl      .MessageWindow
        pop     {r7}

        add     r0,sp,#0xC
        mov     r1,#2
        bl      .WString_Destroy

        mov     r0,r6
        ldr     r1,[sp,#8]
        cmp     r1,#0
        beq     .InfoBox_notimer
        bl      .WindowWidget_SetTimer
.InfoBox_notimer:

        add     sp,sp,#0x14
        pop     {r3-r7,PC}


   /********************************************************/
   /* InfoBoxNew(handle,text,fullscreen{0,1},type)         */
   /*   handle=Parent WND handle                           */
   /*   text=ASCII null-terminated text (\n for new line)  */
   /*   type=Type of dialog (0,3,4,5,6,7)                  */
   /********************************************************/
.align 2
.InfoBoxNew:     @ FullScreen!!!
        push    {r3-r7,LR}
        sub     sp,sp,#0x14
        str     r0,[sp]
        str     r1,[sp,#4]
        str     r2,[sp,#8]
        mov     r5,r3

        mov     r0,#0x68
        bl      .malloc
        mov     r6,r0

        add     r0,sp,#0xC
        ldr     r1,[sp,#4]
        mov     r2,#2
        bl      .WString_MakeFromAscii
        mov     R7, R0
       
        mov     r0,r6
        ldr     r1,[sp]
        add     r2,sp,#0xC
        mov     r3,r5

        push    {r7}
        STR     R7, [SP]
        MOV     R4, #1
        MOV     R7, SP
        STRB    R4, [R7,#4]
        bl      .MessageWindow
        pop     {r7}

        add     r0,sp,#0xC
        mov     r1,#2
        bl      .WString_Destroy

        ldr     r0,[sp,#8]
        cmp     r0,#1
        bne     .InfoBox_end

        ldr     r1,[sp,#8]
        mov     r1,#0
        mov     r2, r1
        STRH    R1, [R6,#4]
        STRH    R2, [R6,#6]
        mov     r0,r6
        mov     r1, #0x60          @ width
        mov     r2, #0x5C          @ height
        STRH    R1, [R6,#8]
        STRH    R2, [R6,#0xA]
 
.InfoBox_end:

        add     sp,sp,#0x14
        pop     {r3-r7,PC}

.endif
.endif

/************************************************************************/
/* FW Timer function                                                    */
/************************************************************************/
.ifdef TIMER
.align 2
.ifdef UFIF
        MyExternalFunc Time_CreateServer   0x0036a935  @ J5 379330 -> J7 369924
        MyExternalFunc Time_DestroyServer  0x0036a941 
        MyExternalFunc Time_SetInterval    0x0036a94d 
        MyExternalFunc Time_Repeat         0x0036a959 

        MyExternalFunc OverrideIdleCounter 0x0036A971
        MyExternalFunc SetTimerMsec        0x0036A981
        MyExternalFunc CurrDateTimeToStr   0x0036A9A5
        MyExternalFunc CurrTimeToStr       0x0036A9c1
        MyExternalFunc CurrDateToStr       0x0036A9d1
.else
.ifdef J7_3.10_4
MyExternalFunc MIPS               0x01EC6B9
MyExternalFunc Time_CreateServer  0x00233673  @ J5 379330 -> J7 369924
MyExternalFunc Time_DestroyServer 0x002336A5 
MyExternalFunc Time_SetInterval   0x002336D7 
MyExternalFunc Time_Repeat        0x00233771 
MyExternalFunc InitIdleCounter    0x00242f89
.endif

.ifdef J7_3.6_5
MyExternalFunc MIPS               0x01eb4e5
MyExternalFunc Time_CreateServer  0x0023265b  @ J5 379330 -> J7 369924
MyExternalFunc Time_DestroyServer 0x0023268d
MyExternalFunc Time_SetInterval   0x002326bf 
MyExternalFunc Time_Repeat        0x00232759
MyExternalFunc InitIdleCounter    0x00241DE3
.endif

.ifdef J6_5.4.2_6
MyExternalFunc MIPS               0x00207BAd
MyExternalFunc Time_CreateServer  0x00251D4b
MyExternalFunc Time_DestroyServer 0x00251D7d
MyExternalFunc Time_SetInterval   0x00251DAf
MyExternalFunc Time_Repeat        0x00251E49
MyExternalFunc InitIdleCounter    0x002645Bf
.endif

.align 2
.OverrideIdleCounter:  @0x0258 - DefaultValue
  push  {lr}
  ldr   r1, ICAddr
  strh  r0, [r1]
  bl    .InitIdleCounter
  pop   {pc}
ICAddr: .word IdleCounterAddr+2

.align 2
.SetTimerMsec:
  push  {lr}
  ldr   r3,TimerMulConst
  lsr   r2,r1,#17
  mul   r2,r3

  lsl   r1,#15
  lsr   r1,#15
  mul   r1,r3

  mov   r3,#1
  lsl   r3,#16

  add   r1,r3
  lsr   r1,#17

  add   r1,r2

  mov   r2,#1
  bl    .Time_SetInterval
  pop   {pc}

.align 2
  TimerMulConst:        .word   28398

.align 2
.CurrDateTimeToStr: @ r0 - string buffer address
  push  {r0-r5, lr}
  ldr   r5, TimeA
  sub   sp, sp, #8
  ldrb  r3, [r5, #4]
  str   r3, [sp, #4]
  ldrb  r3, [r5, #8]
  str   r3, [sp]
  ldrb  r2, [r5, #12]
  ldrb  r3, [r5, #16]
  adr   r1, DateTimeS
  bl    .sprintf
  add   sp, sp, #8
  pop   {r0-r5, pc}

.align 2
.CurrTimeToStr: @ r0 - string buffer address
  push  {r0-r5, lr}
  ldr   r5, TimeA
@  ldrb  r3, [r5]
@  sub   sp, sp, #4
@  str   r3, [sp]
  ldrb  r3, [r5, #4]
  ldrb  r2, [r5, #8]
  adr   r1, TimeS
  bl    .sprintf
@  add   sp, sp, #4
  pop   {r0-r5, pc}

.align 2
.CurrDateToStr: @ r0 - string buffer address
  push  {r0-r5, lr}
  ldr   r5, DateA
  ldrb  r2, [r5]
  ldrb  r3, [r5, #4]
  adr   r1, DateS
  bl    .sprintf
  pop   {r0-r5, pc}

.align 2
TimeA:     .word TimeAddr
DateA:     .word DateAddr
.align 2
TimeS:     .string "%2d:%2d"
@TimeS:    .string "%2d:%2d:%2d"
.align 2
DateTimeS: .string "%02d/%02d %02d:%02d"
.align 2
DateS:     .string "%2d/%2d"
.endif

.endif

/************************************************************************/
/* FW Debug functions                                                   */
/************************************************************************/
.ifdef DEBUG

.ifdef UFIF
        MyExternalFunc LogPrintF 0x036AA19

.else
.ifdef J7_3.10_4
MyExternalFunc CTEDebugPrintF 0x018E7D3
.endif

.ifdef J7_3.6_5
MyExternalFunc CTEDebugPrintF 0x018E051
.endif

.ifdef J6_5.4.2_6
MyExternalFunc CTEDebugPrintF 0x01aff91
.endif
  /********************************************************/
  /* LogPrintF(string,param1,param2,param3)               */
  /*   string=ASCII null-terminated text (\n for new line)*/
  /*   param1..3=printf parameters                        */  
  /********************************************************/ 
.align 2
.LogPrintF:
.printf:
         PUSH    {R0-R3}
         PUSH    {R7,LR}
         ADD     R7, SP, #8
         SUB     SP, SP, #4

         ADD     R0, R7, #0
         ADD     R0, #4
         LSR     R0, R0, #2
         LSL     R0, R0, #2
         STR     R0, [SP]
         LDR     R0, [R7]
         LDR     R1, [SP]
         BL      .CTEDebugPrintF

         ADD     SP, SP, #4
         POP     {R7}
         POP     {R2}
         ADD     SP, SP, #0x10
         MOV     PC, R2

.endif

.endif

/************************************************************************/
/* DIV / MOD random generator                                           */
/************************************************************************/
.ifdef RANDOM
.DivMod:
.divmod:push	{r2,LR}
        MOV     r2,r1
        MOV     r1,r0
        MOV     r0,#0
.divloop:
        CMP     r1,r2
        BLO     .divend
        SUB     r1,r2
        ADD     r0,#1
        B       .divloop
.divend:pop	{r2,PC}
@@        MOV     PC,LR
/**************************************************/
.InitRandom:
.initseed: PUSH  {r0-r1,LR}
          LDR   r0,counter
          .ifdef UFIF
                LDR   r0,[r0]
          .endif
          LDR   r0,[r0]
          ADR   r1,seed
          STR   r0,[r1]
          POP   {r0-r1,PC}
/**************************************************/
.Random:
.random: PUSH    {r1-r6,LR}
         MOV     r1,r0
         LDR     r0,seed
         LDR     r2,num1
         MUL     r0,r2
         LDR     r2,num2
         ADD     r0,r2
         ADR     r2,seed
         STR     r0,[r2]
         LSR     r0,#16
         BL      .divmod
         MOV     r0,r1
         POP     {r1-r6,PC}

.align 2
seed:    .word 0x12345678
num1:    .word 214013
num2:    .word 2531011
counter:                        /* Phone counter - base for random */
.ifdef UFIF
         .word UFIFTimerAddr
.else
         .word TimerAddr
.endif
.endif

/************************************************************************/
/* FW GFX routines                                                      */
/************************************************************************/
.ifdef GFX_MAIN
.ifdef UFIF
        MyExternalFunc GFX_FillRect  0x036AA95
        MyExternalFunc GFX_Frame     0x036AAA1
        MyExternalFunc GetFontStruct 0x036AA89 /*0x1680CF*/ @ 0x8641a0 -> 0x8746d4 
        MyExternalFunc GFX_WriteText 0x036AAAD /*0x0D384F*/

        MyExternalFunc WriteText     0x036AAB9

.else
.ifdef J7_3.10_4
MyExternalFunc GetFontStruct 0x14b3eb /*0x1680CF*/ @ 0x8641a0 -> 0x8746d4 
MyExternalFunc GFX_FillRect  0x0B5D1B
MyExternalFunc GFX_Frame     0x0B5F9D
MyExternalFunc GFX_WriteText 0x0b61f7 /*0x0D384F*/
.endif

.ifdef J7_3.6_5
MyExternalFunc GetFontStruct 0x14abd7 @ 0x8641a0 -> 0x8742D4
MyExternalFunc GFX_FillRect  0x0B5773
MyExternalFunc GFX_Frame     0x0B59F5
MyExternalFunc GFX_WriteText 0x0b5c4f @ not 0x0b5d95
.endif

.ifdef J6_5.4.2_6
MyExternalFunc GetFontStruct 0x0016BE0f
MyExternalFunc GFX_FillRect  0x000D7285
MyExternalFunc GFX_Frame     0x000D7501
MyExternalFunc GFX_WriteText 0x000D775b
.endif
   /********************************************************/
   /* WriteText(handle, x, y, text, font&color)            */
   /*   handle=Parent WND handle                           */
   /*   text=ASCII null-terminated text (\n for new line)  */
   /********************************************************/
.align 2
.WriteText:
  push  {r0-r7,lr}      @ GFX,x,y,text,font&color
  sub   sp,#0x14
  mov   r7,r4
  mov   r4,r0
  mov   r5,r1
  mov   r6,r2

  add   r0,sp,#0xC
  mov   r1,r3
  mov   r2,#2
  bl    .WString_MakeFromAscii

  mov   r0,#0
  str   r0,[sp]

  mov   r0, r7
  lsl   r0, #16
  lsr   r0, #16
  bl    .GetFontStruct  @ Get font #6 - standard
  str   r0,[sp,#4]

  mov   r0,#0
  str   r0,[sp,#8]

  lsr   r0, r7, #16
  str   r0,[sp]

  mov   r0,r4
  mov   r1,r5
  mov   r2,r6
  add   r3,sp,#0xC
  bl    .GFX_WriteText  @(GFX,X,Y,WString,0,Font,0)

  add   r0,sp,#0xC
  mov   r1,#2
  bl    .WString_Destroy
  add   sp,#0x14
  pop   {r0-r7,pc}

.endif

.endif

/************************************************************************/
/* GFX SPITE                                                            */
/************************************************************************/
.ifdef GFX_SPRITE

.ifdef UFIF
        MyExternalFunc DrawSprite      0x036AB01
        MyExternalFunc GetSprite       0x036AB25
        MyExternalFunc DrawKeyLockIcon 0x036AB45
.else
.DrawSprite:    push    {r0-r5,LR}      @ r0=screen ofs r1=sprite r2=in sprite ofs
                ldrb    r3,[r1]
                ldrb    r4,[r1,#1]
                add     r1,r2
_NextRow:       mov     r5,#0
_NextPixel:     ldrb    r2,[r1,#2]
                cmp     r2,#4           @ 4 - transparent color
                beq     _NoPutPixel
                strb    r2,[r0,r5]
_NoPutPixel:    add     r5,#1
                add     r1,#1
                cmp     r5,r3
                bne     _NextPixel
                add     r0,#96
                sub     r4,#1
                cmp     r4,#0
                bne     _NextRow
                pop     {r0-r5,PC}
/**********************************************************************/
.GetSprite:     push    {r0-r5,LR}      @ r0=screen ofs r1=sprite r2=in sprite ofs
                ldrb    r3,[r1]
                ldrb    r4,[r1,#1]
                add     r1,r2
_NextRow1:      mov     r5,#0
_NextPixel1:    ldrb    r2,[r0,r5]
                strb    r2,[r1,#2]
                add     r5,#1
                add     r1,#1
                cmp     r5,r3
                bne     _NextPixel1
                add     r0,#96
                sub     r4,#1
                cmp     r4,#0
                bne     _NextRow1
                pop     {r0-r5,PC}
/**********************************************************************/
.DrawKeyLockIcon:
                push    {r0-r3,LR}
                ldr     r0, vm
                adr     r1, keylockSpr
                mov     r2,#0
                bl      .DrawSprite
                pop     {r0-r3,PC}

.align 2
keylockSpr:     .byte   11,8
                .byte   4,4,3,3,3,4,4,4,4,4,4
                .byte   4,3,0,0,0,3,4,4,4,4,4
                .byte   3,0,0,3,0,0,3,3,3,3,4
                .byte   3,0,0,3,0,0,0,0,0,0,3
                .byte   3,0,0,3,0,0,0,0,0,0,3
                .byte   3,0,0,3,0,0,3,0,0,3,4
                .byte   4,3,0,0,0,3,4,3,0,3,4
                .byte   4,4,3,3,3,4,4,4,3,4,4

.endif
.endif

/************************************************************************/
/* GFX                                                                  */
/************************************************************************/
.ifdef GFX

.ifdef UFIF
        MyExternalFunc getofs         0x036ABB1
        MyExternalFunc putpix         0x036ABC1
        MyExternalFunc hline          0x036ABCD
        MyExternalFunc getpix         0x036ABE1
        MyExternalFunc clrscr         0x036ABED
        MyExternalFunc DrawScreen2bpp 0x036ABFD
        MyExternalFunc SaveScreen2bpp 0x036AC29
        MyExternalFunc loadscreen     0x036AC59
        MyExternalFunc loadscreen2bpp 0x036AC69
.else
.align 2
.getofs:                        /* r0=x r1=y out: r0=ofs - WORKING*/
        PUSH    {r2,LR}
        MOV     r2,#96
        MUL     r1,r2
        ADD     r0,r1
        LDR     r2,vm
        ADD     r0,r2
        POP     {r2,PC}
/**********************************************************************/
.align 2
.putpix:
         PUSH    {r3-r6,LR}           /* r0=x r1=y r2=color   - WORKING*/
         BL      .getofs
         STRB    r2,[r0]
         POP     {r3-r6,PC}
/**********************************************************************/
.align 2
.hline:                         /* r0=x r1=y r2=length r3=color */
        PUSH    {r4-r6,LR}
        BL      .getofs
.hlineloop:
        STRB    r3,[r0]
        ADD     r0,#1
        SUB     r2,#1
        CMP     r2,#0
        BNE     .hlineloop
        POP     {r4-r6,PC}
/**********************************************************************/
.align 2
.getpix:
        PUSH    {LR}
        BL      .getofs
        LDRB    r0,[r0]
        POP     {PC}
/**********************************************************************/
.align 2
.clrscr:                  /* r0=color  - WORKING*/
        PUSH    {r1-r6,LR}
        MOV     r3,r0
        MOV     r0,#0
        MOV     r1,#0
        LDR     r2,vs
        BL      .hline
        POP     {r1-r6,PC}
/**********************************************************************/
.align 2
.DrawScreen2bpp:        @ r0=Dest.Buffer, r1=Src.Buffer
  push  {r0-r5,lr}
  mov   r5,#0x8A
  lsl   r5,#4    @ 96*92/4 = 0x8A0
DSloop:
  ldrb  r4,[r1]

  lsl   r2,r4,#30
  lsr   r2,#6

  lsr   r3,r4,#2
  lsl   r3,#30
  lsr   r3,#14
  orr   r2,r3

  lsr   r3,r4,#4
  lsl   r3,#30
  lsr   r3,#22
  orr   r2,r3

  lsr   r4,#6
  orr   r2,r4

  str   r2,[r0]

  add   r1,#1
  add   r0,#4

  sub   r5,#1
  bne   DSloop

  pop   {r0-r5,pc}
/**********************************************************************/
.align 2
.SaveScreen2bpp:        @ r0=Dest.Buffer, r1=Src.Buffer
  push  {r0-r5,lr}
  mov   r5,#0x8A
  lsl   r5,#4    @ 96*92/4 = 0x8A0
SSloop:
  ldr   r2,[r1]

  lsl   r4, r2, #30
  lsr   r4, #24
  
  lsr   r2, #8
  lsl   r3, r2, #30
  lsr   r3, #26
  orr   r4, r3

  lsr   r2, #8
  lsl   r3, r2, #30
  lsr   r3, #28
  orr   r4, r3

  lsr   r2, #8
  lsl   r3, r2, #30
  lsr   r3, #30
  orr   r4, r3

  strb  r4,[r0]

  add   r1,#4
  add   r0,#1

  sub   r5,#1
  bne   SSloop

  pop   {r0-r5,pc}
/**********************************************************************/
.align 2
.loadscreen:
        PUSH    {r0-r6,LR}
        MOV     r1,r0
        LDR     r0,vm
        LDR     r2,vs
        BL      .memcpy
        POP     {r0-r6,PC}
/**********************************************************************/
.align 2
.loadscreen2bpp:
        PUSH    {LR}
        MOV     r1,r0
        LDR     r0,vm
        BL      .DrawScreen2bpp
        POP     {PC}
/**********************************************************************/

.align 2
vm: .word videoMem
vs: .word 0x2280

.endif

.endif

/************************************************************************/
/* FW Menu Events functions                                             */
/************************************************************************/
.ifdef MENU_EV
/*****************************************************************************
**                                                                          **
**  FUNCTIONS FOR EASY CREATING MENUS                                       **
**                                                                          **
*****************************************************************************/
.ifdef UFIF
        MyExternalFunc MenuInit           0x036ac95
        MyExternalFunc MenuInsItem        0x036ad49
        MyExternalFunc MenuInsItemIcon    0x036ad69
        MyExternalFunc MenuCreate         0x036ad79
        MyExternalFunc ChangeMenuItemIcon 0x036ac7d
        MyExternalFunc ReturnFromMenu     0x036ac89

        MyExternalFunc InitializeListMenu 0x036a8c9
        .GetMenuListObj:
        MyExternalFunc sub_0_261E9C       0x036a8d5
        .DestroyListMenu:
        MyExternalFunc sub_0_261EAE       0x036a8e1
        .CreateListMenuItems:
        MyExternalFunc ListMenuSetItems   0x036a8ed
        .SetListCallback:
        MyExternalFunc sub_0_126B30       0x036a8f9
        .DestroyListItems:
        MyExternalFunc sub_0_256C54       0x036a905
        .GetListSelectedId:
        MyExternalFunc GetMenuEvent       0x036a911
.else
.ifdef J7_3.10_4
MyExternalFunc InitializeListMenu 0x0243D55
.GetMenuListObj:
MyExternalFunc sub_0_261E9C       0x0243DBD
.DestroyListMenu:
MyExternalFunc sub_0_261EAE       0x0243DCF
.CreateListMenuItems:
MyExternalFunc ListMenuSetItems   0x01BC5DD
.SetListCallback:
MyExternalFunc sub_0_126B30       0x0105419
.DestroyListItems:
MyExternalFunc sub_0_256C54       0x023A8BD
.GetListSelectedId:
MyExternalFunc GetMenuEvent       0x0105109
@ r0 - menu widget, r1 - ItemID, r2 - IconID
MyExternalFunc ChangeMenuItemIcon 0x01BC6D5
@ r0 - menu widget, r1 - 0x63???, r2 - MenuItemID???, if r1=r2 - fast exit
MyExternalFunc ReturnFromMenu     0x016F0E5
.endif

.ifdef J7_3.6_5
MyExternalFunc InitializeListMenu 0x0242BA5
.GetMenuListObj:
MyExternalFunc sub_0_261E9C       0x0242C0D
.DestroyListMenu:
MyExternalFunc sub_0_261EAE       0x0242C1F
.CreateListMenuItems:
MyExternalFunc ListMenuSetItems   0x01BB37D
.SetListCallback:
MyExternalFunc sub_0_126B30       0x0104D55
.DestroyListItems:
MyExternalFunc sub_0_256C54       0x02398CD
.GetListSelectedId:
MyExternalFunc GetMenuEvent       0x0104A45
MyExternalFunc ChangeMenuItemIcon 0x01bb475
MyExternalFunc ReturnFromMenu     0x016e911
.endif

.ifdef J6_5.4.2_6
MyExternalFunc InitializeListMenu 0x00263B09
.GetMenuListObj:                    
MyExternalFunc sub_0_261E9C       0x00263B71
.DestroyListMenu:                   
MyExternalFunc sub_0_261EAE       0x00263B83
.CreateListMenuItems:               
MyExternalFunc ListMenuSetItems   0x001D8D81
.SetListCallback:                   
MyExternalFunc sub_0_126B30       0x00127969
.DestroyListItems:                  
MyExternalFunc sub_0_256C54       0x0025945D
.GetListSelectedId:                 
MyExternalFunc GetMenuEvent       0x00127659
MyExternalFunc ChangeMenuItemIcon 0x001d8e79
MyExternalFunc ReturnFromMenu     0x001907A5
.endif

.align 2
.MenuInit:    @ initialize menu structure
              @ r0 - parent menu widget
              @ r1 - number of menulistItems
              @ r2 - OnItemClick func address
              @ r3 - OnDestroy func address
              @ sp - MenuTitle
              @ sp+4 - MenuIconID
              @ return menu widget address, or 0 if error
  push  {r4-r7,lr}
  sub   sp,#0x0C                      
                                      @ +08 lenght of menuitems and its names

        @ Allocate memory for menu widget
        @ structure: +0x000 ...  0x64 ... Used internally
        @             offset: 0x10  dword  -  Pointer to default function table
        @                                     now it will point to our func table
        @                                     in offset +0x6C
        @             offset: 0x60  dword  -  Set ListCallback here.
        @            +0x064 ...     4 ... (reserved) Use for your own needs
        @            +0x068 ...     4 ... (reserved) Use for your own needs
        @            +0x06C ... 0x150 ... Function table of menu widget
        @             offset: 0xDC dword   -  Pointer to OnDestroyEvent
        @             offset: 0xF8 dword   -  Pointer to some Initialize function
        @             offset:0x148 dword=0 -  
        @             offset:0x14C dword   -  Pointer to OnClickEvent
        @            +0x1BC ...  0x18 ... Function table of list callback

        @            +0x1D4 ...  0x17c ... Menu items (19 * 20 bytes)
        @            +0x350 ...  0x240 ... Menu item names (18*32 chars unicode)

  mov   r5, r0
  mov   r6, r2
  mov   r7, r3

  mov   r0,#0x75
  lsl   r0,#2    @ 0x64 + 8 + 0x150 + 0x18 = 0x1D4

  mov   r2, #0x14    
  mul   r2, r1       @ R2 = 20 * menu_items_count = size of menuitems struct

@  mov   r3, #0x20   @ 32 - menuitem name length
@  mul   r3, r1      @ menuitems names length
@  add   r2, r3
  str   r2, [sp, #8] @ store menuitems struct length at sp+8

  add   r0, r2

  bl    .malloc
  cmp   r0,#0
  beq   init_end_err                @ Not enough memory -> exit
  mov   r4,r0                       @ R4 = pointer to struct

  mov   r0,sp
  ldr   r1,[sp,#0x20]               @ MenuTitle at SP
  mov   r2,#2
  bl    .WString_MakeFromAscii      @ Create WString in stack from MenuTitle


  mov   r0,r4                       @ = pointer to destination struct
  mov   r1,r5                       @ = parent menu adr
  mov   r2,sp                       @ = pointer to WString with title
  ldr   r3,[sp,#0x24]               @ MenuIcon at SP+4
  bl    .InitializeListMenu         @ Create list menu widget

  mov   r0,sp
  mov   r1,#2
  bl    .WString_Destroy            @ Destroy WString, not used any more

  mov   r0,#0x6C
  add   r0,r4
  mov   r5,r0                      @ R5 = Pointer to function table of menu

  ldr   r1,[r4,#0x10]              @ R1 = Default table (set internally)
  mov   r2,#0x29
  lsl   r2,#3    @ 0x148           @ = size
  bl    .memcpy                    @ Copy default table to the struct

  str   r5,[r4,#0x10]              @ Set the table pointer to the new address

  mov   r1,r7
  add   r1,#1
  mov   r0,r5
  add   r0,#0xDC                   @ Point OnDestroy event func. address to
  str   r1,[r0]                    @ Func_Destroy function below

  add   r5,#0xFF
  add   r5,#0x49 @ 0x148
  mov   r0,#0                      @ Clear the first dword of added function
  str   r0,[r5]                    @ to zero

  mov   r0,r6
  add   r0,#1
  add   r5,#4    @ 0x14C           @ Point the new added function to
  str   r0,[r5]                    @ item click event function Func_ItemClick


  mov   r0,#0x6F
  lsl   r0,#2    @ 0x1BC
  add   r0,r4                      @ Set menu object's pointer to list's
  str   r0,[r4,#0x60]              @ callback to our callback structure
  mov   r5,r0                      @ R5 = its address

  mov   r2,#0x18
  adr   r1,MenuListCallback
  bl    .memcpy                    @ Copy the common parts there

  mov   r1,r6
  add   r1,#1
  str   r1,[r5,#0xC]               @ Set the func.#1 address (OnClick event)

  mov   r1,r7
  add   r1,#1
  str   r1,[r5,#0x14]              @ Set the func.#2 address (OnDestroy event)

  mov   r0,#0x75
  lsl   r0,#2    @ 0x64 + 8 + 0x150 + 0x18 = 0x1D4
  add   r0,r4

  mov   r1,#0
  ldr   r2, [sp, #8]                @ length
  bl    .memset                     @ Clear menuitems struct!!!! Important!

  mov   r0, r4
init_end_err:
  add   sp,#0x0C                      @ Return to parent, the menu should
  pop   {r4-r7,pc}                 @ be created

/*****************************************************************************/

.align 2
.A2U:                              @ Convert from ascii to unicode
      @ r0 - source ASCII
      @ r2 - dest UNICODE
  push  {r0-r3,lr}
  mov   r3,#0                       @ R3 = char counter
mm_a2uloop:
  ldrb  r1,[r0]
  strh  r1,[r2]
  cmp   r1,#0
  beq   mm_a2uend                   @ If <NUL> char found, end the loop
  add   r0,#1
  add   r2,#2
  add   r3,#1
  cmp   r3,#16
  blt   mm_a2uloop                  @ Repeat 16 times (max. 16 chars)
mm_a2uend:
  pop   {r0-r3,pc}

/*****************************************************************************
**           DCW 1                             <--- Bitmask                 **
**           DCW 0x963                         <--- Item-ID                 **
**           DCD 0x3001   pointer to caption or LNG-ID                      **
**           DCD 0        always 0                                          **
**           DCD 0xE8B5   IconID                                            **
**           DCD 0x4030   Marker (in J70 3.10/4 must be 0x4030)             **
**           ........                                                       **
**           ........                                                       **
**           DCW FFFF                                                       **
**           DCW 0                                                          **
**           DCD 0         The last item of menu <-----'                    **
**           DCD 0                                                          **
**           DCD 0                                                          **
**           DCD 0x4030   Marker (in J70 3.10/4 must be 0x4030)             **
**                                                                          **
*****************************************************************************/
.align 2
.MenuInsItem: @ Insert Menu Item in structure
              @ r0 - menu items start address
              @ r1 - Item number
              @ r2 - bitmask(lo hword) & itemID(hi hword)
              @ r3 - Item Caption or LangID
              @ return menu widget address, or 0 if error
  push  {r0-r5,lr}
  mov   r4, r0

  mov   r5, #0x14   @ 20 * menuitem length
  mul   r5, r1      @ menuitems length

  add   r5, r4
  str   r2, [r5]
  str   r3, [r5, #4]

  mov   r0, #0
  str   r0, [r5, #8] @ always 0

  mov   r0, #0
  str   r0, [r5, #0xC] @zero IconID

  mov   r0,#0x40
  lsl   r0,#8
  add   r0,#0x30                    @ R0 = 0x4030 marker (used in each item)
  str   r0,[r5,#0x10]               @ Store 0x4030 marker

  pop   {r0-r5,pc}                 @ be created

/*****************************************************************************/

.align 2
.MenuInsItemIcon:
              @ Insert Icon to MenuItem
              @ r0 - menu items start address
              @ r1 - Item number
              @ r2 - IconID
              @ return menu widget address, or 0 if error
  push  {r0-r5,lr}
  mov   r4, r0

  mov   r5, #0x14   @ 20 * menuitem length
  mul   r5, r1      @ menuitems length

  add   r5, r4
  str   r2, [r5, #0xC] @ insert IconID

  pop   {r0-r5,pc}                 @ be created

/*****************************************************************************/

.align 2
.MenuCreate: @ Create Menu
             @ r0 - menu widget address
             @ r1 - menu list struct address
             @ r2 - menu mask
  push  {r4-r6,lr}                 @ be created
  sub   sp,#0x0C   
  mov   r4, r0
@  mov   r6, r1

@  mov   r1,r6                      @ = address of items structure
  mov   r0,#0                      @ = dest. address, 0->allocate in the func.
@  mov   r2,#0xFF                   @ = mask, we want to see all items
  bl    .CreateListMenuItems       @ Make object with items to use with
  mov   r5,r0                      @ menu list methods

  mov   r0,r4
  bl    .GetMenuListObj            @ Get list object of the menu widget
  ldr   r3,[r0,#0x10]
  add   r3,#0xF8                   @ Get function at 0xF8 from the table
  mov   r1,#0
  ldrsh r1,[r3,r1]                 @ R1 = object/parent address difference
  ldr   r3,[r3,#4]                 @ R3 = function address
  add   r0,r1                      @ Parameter #1 (R0) = self (menu object)
  mov   r1,r5                      @ Parameter #2 (R1) = R5 (items object)
  mov   r2,#2                      @ Parameter #3 (R2) = 2
  mov   lr,pc
  bx    r3                         @ Call method at 0xF8 (Set items, probably)

  mov   r0,r4
  bl    .GetMenuListObj            @ Get list object of the menu widget
  mov   r1,r4
  add   r1,#0x60
  bl    .SetListCallback           @ Set list callback to struct. at 0x60

  add   sp,#0x0C   
  pop   {r4-r6,pc}

/*****************************************************************************/
.endif

.endif

.ifdef J7_3.10_4
MyExternalFunc DisableWatchDog 0x2310C6
MyExternalFunc PowerOff        0x0A5EB7
MyExternalFunc MelodyPlay      0x1F5837
.endif

.ifdef J7_3.6_5
MyExternalFunc DisableWatchDog 0x2302F3
MyExternalFunc PowerOff        0x0A58Eb
MyExternalFunc MelodyPlay      0x1F4BEb
.endif

.ifdef J6_5.4.2_6
MyExternalFunc DisableWatchDog 0x25656b
MyExternalFunc PowerOff        0x0D9CE3
MyExternalFunc MelodyPlay      0x211D93
.endif
