/**************************************************************************/
/*                                                                        */
/* Boulder Dash Remake v1.0b                      (c) RHoST 2003          */
/*                                                                        */
/*                                                                        */
/**************************************************************************/
/* Key 2,4,6,8,*        */
.text
.code 16
.globl _start
.align 4
.word 0x20000000      @ Universal version for PRGLoader 2.0
.string "BoulderDash1bU"  @ Program Name 15 chars max
.org 0x14
.xdef UFIF   
@.equ J6_5.4.2_6,0
_start:
  b    .Main
.xdef DISPLAY            @ memory management functions
.xdef MEMORY             @ memory management functions
.xdef STRINGS            @ strings functions          
.xdef NVM               @ NVM functions              
.xdef WINDOWS            @ windows functions          
.xdef MENU_EV           @ Menu Events functions      
.xdef MONITOR           @ Monitor Mode function      
.xdef TIMER              @ Timer function      
.xdef NIMAR_DELAY       @ Delay :) functions
.xdef DIRECT_KEYBOARD   @ Keyboard functions
.xdef DEBUG              @ Debug functions            
.xdef RANDOM
.xdef ROOT_GFX
.xdef GFX
.include "Jxx_NM_Lib_OOK2_UFIF.h"
.align 2

@@.macro ExternalFunc Address Name
@@.align 2
@@.\Name:
@@  push  {r0-r1}
@@  ldr   r0,_\Name
@@  str   r0,[sp,#4]
@@  pop   {r0,pc}
@@_\Name:
@@  .word \Address
@@.endm

/**************************************************************************/
/* Addresses that need porting                                            */
/**************************************************************************/
@@  ExternalFunc 0x00211453 GetWindowManager       @KeeN@ 0x001f544b 
@@  ExternalFunc 0x001A16AD GetWindowById          @@ 0x018AD41 
@@  ExternalFunc 0x001B0489 cWindowWidget_Create   @@ 0x0018cded 
@@  ExternalFunc 0x001F3206 memset                 @@ 0x01D6B87 
@@  ExternalFunc 0x0026B4CD malloc                 @@ 0x024A9AD 
@@  ExternalFunc 0x000C7E59 free                   @@ 0x00A0AC9 
@@  ExternalFunc 0x0026DFED memcpy                 @@ 0x0011079 
@@  ExternalFunc 0x0005C429 WString_MakeFromAscii  @@ 0x005ADF9 
@@  ExternalFunc 0x0005C521 WString_Destroy        @@ 0x005AEF1 
@@  ExternalFunc 0x00107E01 MessageWindow          @@ 0x00E81F1 
@@  ExternalFunc 0x001B06C1 WindowWidget_SetTimer  @@ 0x018D025 
@@  ExternalFunc 0x00251D4b Time_CreateServer      @@ 0x00233673 
@@  ExternalFunc 0x00251D7d Time_DestroyServer     @@ 0x002336A5  
@@  ExternalFunc 0x00251DAf Time_SetInterval       @@ 0x002336D7  
@@  ExternalFunc 0x00251E49 Time_Repeat            @@ 0x00233771  
@@  ExternalFunc 0x001A1401 WindowRepaint          @@ 0x001FC54D  
@@    ExternalFunc 0x00211D93 MelodyPlay            @@ 0x001F5837
@@  .equ VidMemAddr,0x0301B380 @@ 0x0301BD2C
@@  .equ PhoneCounterAddr,0x0084D98C
@@  .equ RepaintAddr,0x0301D633@@0x00CB38D


/**************************************************************************/

/********* FW functions *********/
@@.repaint:
@@  push {r0-r1,LR}
@@  ldr  r1,_repaint
@@  mov  r0,#0
@@  mov  lr,pc
@@  bx   r1
@@  pop  {r0-r1,PC}
@@.align 2
@@_repaint:  .word RepaintAddr

/**********************************************************************/
/* Video routines                                                     */
/**********************************************************************/
@@.getofs:                        /* r0=x r1=y out: r0=ofs - WORKING*/
@@        PUSH    {r2,LR}
@@        MOV     r2,#96
@@        MUL     r1,r2
@@        ADD     r0,r1
@@        LDR     r2,vidmem
@@        ADD     r0,r2
@@        POP     {r2,PC}
/**********************************************************************/
@@.putpix:
@@         PUSH    {r3-r6,LR}           /* r0=x r1=y r2=color   - WORKING*/
@@         BL      .getofs
@@         STRB    r2,[r0]
@@         POP     {r3-r6,PC}
/**********************************************************************/
@@.hline:                         /* r0=x r1=y r2=length r3=color */
@@        PUSH    {r0-r3,LR}
@@        BL      .getofs
@@.hlineloop:
@@        STRB    r3,[r0]
@@        ADD     r0,#1
@@        SUB     r2,#1
@@        CMP     r2,#0
@@        BNE     .hlineloop
@@        POP     {r0-r3,PC}
/**********************************************************************/        
.vline:                         /* r0=x r1=y r2=length r3=color */
        PUSH    {r0-r3,LR}
        BL      .getofs
.vlineloop:
        STRB    r3,[r0]
        ADD     r0,#96
        SUB     r2,#1
        CMP     r2,#0
        BNE     .vlineloop
        POP     {r0-r3,PC}        
/**********************************************************************/
@@.getpix:
@@        PUSH    {LR}
@@        BL      .getofs
@@        LDRB    r0,[r0]
@@        POP     {PC}
/**********************************************************************/
@@.clrscr:                  /* r0=color  - WORKING*/
@@        PUSH    {r1-r6,LR}
@@        MOV     r3,r0
@@        MOV     r0,#0
@@        MOV     r1,#0
@@        LDR     r2,vidsize
@@        BL      .hline
@@        POP     {r1-r6,PC}
/**********************************************************************/
@@.loadscreen:
@@        PUSH    {r0-r6,LR}
@@        MOV     r1,r0
@@        LDR     r0,vidmem
@@        LDR     r2,vidsize
@@        BL      .memcpy
@@        POP     {r0-r6,PC}
/**********************************************************************/
@@.align 2
@@vidmem:
@@.ifdef UFIF
@@         .word UFIFvideoMem
@@.else
@@         .word videoMem
@@.endif
@@vidsize: .word 0x2280

@______________________________________________________________________________
.SmallDelay:  @ 쪠 প
	push {r0-r2,lr}
	MOV  	r2,#10
delay_0:
	MOV  	r1,#100
delay_1:
	MOV  	r0,#100
delay_2:
	sub 	r0,#1
	cmp 	r0,#0
	bne 	delay_2

	sub 	r1,#1
	cmp 	r1,#0
	bne 	delay_1

	sub 	r2,#1
	cmp 	r2,#0
	bne 	delay_0
	pop {r0-r2,PC}
@______________________________________________________________________________


/**********************************************************************/
/* Div/Mod, random generator                                          */
/**********************************************************************/
@@.divmod:
@@	push	{r2,LR}
@@        MOV     r2,r1
@@        MOV     r1,r0
@@        MOV     r0,#0
@@.divloop:
@@        CMP     r1,r2
@@        BLO     .divend
@@        SUB     r1,r2
@@        ADD     r0,#1
@@        B       .divloop
@@.divend:
@@        pop	{r2,PC}
/**************************************************/
@@.initseed: PUSH  {r0-r1,LR}
@@          LDR   r0,counter
@@          LDR   r0,[r0]
@@          ADR   r1,seed
@@          STR   r0,[r1]
@@          POP   {r0-r1,PC}
/**************************************************/
@@.random: PUSH    {r1-r6,LR}
@@         MOV     r1,r0
@@         LDR     r0,seed
@@         LDR     r2,num1
@@         MUL     r0,r2
@@         LDR     r2,num2
@@         ADD     r0,r2
@@         ADR     r2,seed
@@         STR     r0,[r2]
@@         LSR     r0,#16
@@         BL      .divmod
@@         MOV     r0,r1
@@         POP     {r1-r6,PC}

.align 2
@@seed:    .word 0x12345678
@@num1:    .word 214013
@@num2:    .word 2531011
@@counter: .word PhoneCounterAddr       /* Phone counter - base for random */

.align 2
.ReSetTimer:
	push	{r0-r1,LR}
	adr	r1,Speed
	ldr	r0,[r1]
	cmp	r0,#1
	beq	_NoReSet
	sub	r0,#1
	str	r0,[r1]
_NoReSet:
	pop	{r0-r1,PC}


/****************************/
/*********[ Events ]*********/
/****************************/

.align 1
.CallOldEvent:
  push {r5}
  ldr  r5,OldEvents
  lsl  r4,r4,#3
  add  r4,r4,#12
  ldr  r4,[r5,r4]
  pop  {r5}
  bx   r4

.SetNewEvent:
  ldr  r2,NewEvents
  lsl  r0,r0,#3
  add  r0,r0,#12
  str  r1,[r2,r0]
  mov  pc,lr

.HookEvents:
  push {r4-r5,lr}
  mov  r4,r0

  mov  r0,#0xA4  /* 2*41*8 = 0x290 */
  lsl  r0,r0,#2

  mov  r1,#8
  add  r0,r0,r1

  bl   .malloc
  adr  r1,OldEvents
  str  r0,[r1]

  ldr  r1,[r4,#0x10]
  mov  r2,#0xFF
  add  r2,r2,#0x49
  bl   .memcpy

  mov  r1,r0
  mov  r2,#0xFF
  add  r2,r2,#0x49
  add  r0,r0,r2
  adr  r5,NewEvents
  str  r0,[r5]
  mov  r5,r0
  bl   .memcpy
                           /* Here you can set any event handler */
  mov  r0,#0x15
  adr  r1,.NewEvent_Key
  add  r1,r1,#1
  bl   .SetNewEvent

  mov  r0,#0x1A
  adr  r1,.NewEvent_Destroy
  add  r1,r1,#1
  bl   .SetNewEvent

  mov  r0,#0x13
  adr  r1,.NewEvent_Paint
  add  r1,r1,#1
  bl   .SetNewEvent

  mov  r0,#0x29
  adr  r1,.MyTimerFunc
  add  r1,r1,#1
  bl   .SetNewEvent

  str  r5,[r4,#0x10]
  pop  {r4-r5,pc}

@_______________________________________________________________________________
.UnhookEvents:
  push {lr}
  ldr  r0,OldEvents
  bl   .free
  pop  {pc}
@_______________________________________________________________________________

.align 2
OldEvents: .word 0
NewEvents: .word 0

@_______________________________________________________________________________
/********* Main *********/
.Main:
  push {r4-r7,lr}
  mov     r6,r0

 @ You can place some initialization code here,
 @ but you can use OnCreate event too

  bl      .GetWindowManager
  mov     r5,r0

  mov     r0,#0x70
  bl      .malloc
  mov     r4,r0

  mov     r0,r6
  cmp     r0,#0
  bne     .skip_wnd
  mov     r0,#0x7D
  lsl     r0,r0,#4
  bl      .GetWindowById
.skip_wnd:

  mov     r2,r5
  mov     r1,r0
  mov     r0,r4
  bl      .cWindowWidget_Create

  mov     r0,r4
  bl      .HookEvents

  adr     r0,TimerFuncs
  str     r0,[r4,#0x4C]

  adr     r1,.MyTimerFunc
  add     r1,#1
  str     r1,[r0,#0xC]
  adr     r1,.NewEvent_Destroy
  add     r1,#1
  str     r1,[r0,#0x14]

  mov     r0,#0x50
  add     r0,r4,r0
  mov     r1,#0x4C
  add     r1,r4,r1
  bl      .Time_CreateServer

  mov     r0,#0x50
  add     r0,r4,r0
  ldr     r1,Interval
  mov     r2,#1
  bl      .Time_SetInterval  /* Init timer */

@ ⨬ ࠭
	mov	r5,r0
	mov	r0,#3
	bl	.clrscr
	mov	r0,r5
	bl	.repaint
@ 㧨  ஢ 
	mov	r0,#0
	bl	.LoadMap
  mov     r0,r4
  pop     {r4-r7,pc}
@_______________________________________________________________________________

.align 4
Interval:    .word 0x14    /* Not in ms - smaller -> shorter time */
TimerFuncs:  .word 0x4C  /* Functions base for timer event structure */
             .word 0
             .word 0xFFB4
             .word 0x0
             .word 0xFFB4
             .word 0x0

.align 2
.NewEvent_Destroy:            @@@@@@@@ OnDestroy @@@@@@@@
  push {r4,lr}
  push {r0-r3}

  mov  r1,#0x50
  add  r0,r0,r1
  mov  r1,#2                 /* Destroy timer */
  bl   .Time_DestroyServer

  @ Place your deinitialization here
  @  (some free(), etc)

  pop  {r0-r3}
  mov  r4,#0x1A
  bl   .CallOldEvent
  bl   .UnhookEvents
  pop  {r4,pc}


/****************************************/
/*********[ New event handlers ]*********/
/****************************************/

.align 2
.NewEvent_Key:                @@@@@@@@ OnKeyPressed @@@@@@@@
  push {r4-r5,lr}
  push {r0-r3}
  ldrh r2,[r1,#0xE]
  ldrh r1,[r1,#0xC]

  @ Your keyhandler code here
  @  r2 - Key scancode
  @       0x30 .. 0x39 - "0".."9"
  @       0x23 - "#"
  @       0x2a - "*"
  @  r1 - Event type (101h,106h,107h,...)
  @          0x106 - key pressed
  @          0x107 - key unpressed
  @        0x101 & scan 0x09 - RedButton pressed
  @        0x101 & scan 0x56 - CenterKey pressed
  @        0x101 & scan 0x08 - CenterKey holded
  @        0x101 & scan 0x07 - CenterKey unpressed
  @        0x101 & scan 0x0b - GreenButton pressed
  @        0x101 & scan 0x03 - JogUp
  @        0x101 & scan 0x05 - JogDown
  @        0x101 & scan 0x56 - JogPress
  @        0x101 & scan 0x4d - JogRelase
  @        0x101 & scan 0x0c - JogHold

@	adr	r4,melody_num
@	ldr	r0,[r4]		@ 㧨 祭
@	mov	r3,#2		@ ஢塞  ᮡ⨥ 101
@	add	r3,#0xff
@	cmp	r1,r3
@	bne	_NoSound
@	cmp	r2,#0x5		@ Jog Down
@	bne	_CheckJogUp
@	add	r0,#1
@	push	{r0-r7}
@	bl	.MelodyPlay	@ ࠥ 
@	pop	{r0-r7}
@_CheckJogUp:
@        cmp	r2,#0x3		@ Jog Up
@	bne	_NoSound
@	sub	r0,#1
@	push	{r0-r7}
@	bl	.MelodyPlay	@ ࠥ 
@	pop	{r0-r7}
@_NoSound:
@	str	r0,[r4]		@ ࠭  ६

	bl	.GetDirectAdr	@   ६   

	mov  r3,#7		@ ஢塞  ᮡ⨥  ⨥ 
	add  r3,#0xff
	cmp  r1,r3
	bne  _NoMoving

@  襬 祭   ६
	strb	r2,[r0]
	b	_ExitKey
_NoMoving:
	mov	r2,#0
	strb	r2,[r0]	
_ExitKey:
	pop  {r0-r3}               /* In every handler you NEED to pass   */
	mov  r4,#0x15              /* old registers r0-r3 to CallOldEvent */
	bl   .CallOldEvent
	pop  {r4-r5,pc}
@______________________________________________________________________________

@______________________________________________________________________________
.align 2
.NewEvent_Paint:
  push {r4-r5,lr}
  mov  r5,r0
  mov  r4,#0x13
@  bl   .CallOldEvent       /* for widget this clear screen to color 3 */

@   뢠 ᢮ 㭪樨

  pop  {r4-r5,pc}          @@ After return, screen is repainted, you don't
                           @@ need to call Repaint in this Paint_event
@______________________________________________________________________________

@_______________________________  ______________________________________
.align 2
.MyTimerFunc:                 @@@@@@@@ OnTimer @@@@@@@@
  push {r4-r6,lr}
  mov  r4,r0  

  adr	r5,TimeReSet
  ldr	r6,[r5]

  ldrb	r0,Started
  cmp	r0,#0
  beq	_TContinue

  ldr	r0,mode2X
  cmp	r0,#0
  beq	_TDec2
  sub	r6,#1
_TDec2:
  sub	r6,#1		@Impostazione velocit
  cmp	r6,#0
  bgt	_TNoReSet
  ldr	r6,Speed

_TContinue:

  mov  r0,r4             @@ This will repaint the window using Paint event
  bl   .WindowRepaint    @@ Use this metod for drawing, don't draw in timer

_TNoReSet:
  str	r6,[r5]
  
  ldr	r0,Started
  cmp	r0,#0
  beq	_TNoChangeSpeed
  
  adr	r5,TimeChange
  ldr	r6,[r5]
  sub	r6,#1
  cmp	r6,#0
  bgt	_TNoChangeSpeed
  bl	.ReSetTimer
  ldr	r6,TimeBuild
_TNoChangeSpeed:
  str	r6,[r5]

@  ᢮  맮 㭪権   ⠩_____________ _ _ _ _ _ _ _ _ _ _
	bl	.CheckKeyboard
	bl	.DecTime	@ 楤 ⠥ ६  ᫨  㡨 
	bl	.CheckViewMove	@ ஢塞 㦭    ᬮ   
	bl	.MapLife 	@     .
	bl	.MapLife 	@     .
	bl	.DrawMapXY	@ ᮢ뢠 
	bl	.MapLife 	@     .
	bl	.MapLife 	@     .
	bl	.DrawState	@ ﭨ,஢ઠ 䫠 ᬥ,१
	bl	.MapLife 	@     .
	bl	.MapLife 	@     .

_TNoDidIt:
  mov  r0,#0x50
  add  r0,r4,r0
  bl   .Time_Repeat        /* Refresh timer - only one parameter r4+0x50 */

  pop  {r4-r6,pc}
  
.align 2
TimeBuild: .word 2000

/**********************************************************************/
 
.align 2
Speed:	 .word 10
.align 2
Started: .byte 0

.align 2
TimeReSet: .word 1
TimeChange: .word 2000

.align 2
mode2X:	   .word 0
stepX:	   .word 0

@______________________________________________________________________________
.CheckKeyboard:  @ 楤 ஢ 祭 ६   
	push	{r0-r7,LR}

	bl	.GetDirectAdr	@   ६   
	ldrb	r2,[r0]		@ 㧨 祭
	cmp	r2,#0x34	@'4'
	bne	_NextRight
	bl	.CheckLeft
_NextRight:
	cmp	r2,#0x36	@'6'
	bne	_NextDown
	bl	.CheckRight
_NextDown:
	cmp	r2,#0x38	@'8'
	bne	_NextUp
	bl	.CheckDown
_NextUp:
	cmp	r2,#0x32	@'2'
	bne	_NextZvezda
	bl	.CheckUp
_NextZvezda:
	cmp	r2,#0x2a	@'*'
	bne	_NoMovingKey
	mov	r0,#0		@ १ ⥪騩 ஢
	bl	.GotoNextLevel
_NoMovingKey:
	pop	{r0-r7,PC}
@______________________________________________________________________________

@______________________________________________________________________________
.CheckDown:
@ 楤 ஢     
	push	{r0-r7,LR}
	bl	.GetMapAddr
	mov	r4,r0		@     r0
	bl	.GetHeroYAdr    @ 㧨 न 
	ldrb	r1,[r2]
	bl	.GetHeroXAdr    @ 㧨 न 	
	ldrb	r0,[r2]

@ ⥯ 室 ᫨  室     
	add	r1,#1           @ =(Hero_y+1)*X_size+Hero_x
	mov	r3,r1		@ ࠭塞 r1  r3    न
	mov	r2,#x_size      
	mul	r1,r2
	add	r1,r0		
	mov	r2,r4		@  
	add	r2,r1		@ 饭   ஢ન
	ldrb	r2,[r2]		@ 㧨  쥪

	cmp	r2,#1		@ ᫨  ࠢ,   
	beq	_MoveDown
	cmp	r2,#4		@ ᫨  ⮥  
	beq	_MoveDown
	cmp	r2,#5		@ ᫨     
	beq	_MoveDown	
	cmp	r2,#8		@ ᫨   ଠ
	beq	_MoveDown
	cmp	r2,#9		@ ᫨   
	beq	_MoveDown
	b	_NoMoveDown
_MoveDown:
@  室  ஥  , 㢥 Y 
@ ஢    
	bl	.Draw_Zero	@ ࠥ ண 
	mov	r4,r2		@  ஢ન  
	bl	.GetHeroYAdr    @ 㧨  ६ Y न 
	strb	r3,[r2]		@  न  ⠭

	bl	.SetHeroToMap	@ ⠭    

	cmp	r4,#5		@ ᫨  -⠪  , 稪 +1
	bne	_ScoreDown
	bl	.IncAlmaz	@ 稢 稪 
	mov	r4,#AlmazScore	@  
	bl	.IncScores
	b	_NoMoveDown
_ScoreDown:
	cmp	r4,#1		@  뫠 ࠢ?
	bne	_CheckExitDown	@ ஢ਬ  室  ?
	mov	r4,#TravaScore	@  ࠢ
	bl	.IncScores	@ ⠥ 窨
_CheckExitDown:
	cmp	r4,#8
	beq	_VorotaDownOk
	cmp	r4,#9
	beq	_VorotaDownOk
	b	_NoMoveDown
_VorotaDownOk:
	mov	r0,#1		@ 稠 ᫥騩 ஢
	bl	.GotoNextLevel
_NoMoveDown:
	pop	{r0-r7,PC}
@______________________________________________________________________________


@______________________________________________________________________________
.CheckUp:
@ 楤 ஢     
	push	{r0-r7,LR}
	bl	.GetMapAddr
	mov	r4,r0		@     r0
	bl	.GetHeroYAdr    @ 㧨 न 
	ldrb	r1,[r2]
	bl	.GetHeroXAdr    @ 㧨 न 	
	ldrb	r0,[r2]

@ ⥯ 室 ᫨  室     

	sub	r1,#1           @ =(Hero_y-1)*X_size+Hero_x
	mov	r3,r1		@ ࠭塞 r1  r3    न
	mov	r2,#x_size      
	mul	r1,r2
	add	r1,r0		
	mov	r2,r4		@  
	add	r2,r1		@ 饭   ஢ન
	ldrb	r2,[r2]		@ 㧨  쥪

	cmp	r2,#1		@ ᫨  ࠢ,   
	beq	_MoveUp
	cmp	r2,#4		@ ᫨  ⮥  
	beq	_MoveUp
	cmp	r2,#5		@ ᫨     
	beq	_MoveUp	
	cmp	r2,#8		@ ᫨   ଠ
	beq	_MoveUp
	cmp	r2,#9		@ ᫨   
	beq	_MoveUp
	b	_NoMoveUp
_MoveUp:
@  室  ஥  , 㢥 Y 
@ ஢    
	bl	.Draw_Zero	@ ࠥ ண 
	mov	r4,r2		@  ஢ન  
	bl	.GetHeroYAdr    @ 㧨 न 
	strb	r3,[r2]		@  न  ⠭

	bl	.SetHeroToMap	@ ⠭    

	cmp	r4,#5		@ ᫨  -⠪  , 稪 +1
	bne	_ScoreUp
	bl	.IncAlmaz	@ 稢 稪 
	mov	r4,#AlmazScore	@  
	bl	.IncScores
	b	_NoMoveUp
_ScoreUp:
	cmp	r4,#1		@  뫠 ࠢ?
	bne	_CheckExitUp
	mov	r4,#TravaScore	@  ࠢ
	bl	.IncScores	@ ⠥ 窨
_CheckExitUp:
	cmp	r4,#8
	beq	_VorotaUpOk
	cmp	r4,#9
	beq	_VorotaUpOk
	b	_NoMoveUp
_VorotaUpOk:
	mov	r0,#1		@ 稠 ᫥騩 ஢
	bl	.GotoNextLevel
_NoMoveUp:
	pop	{r0-r7,PC}
@______________________________________________________________________________

@______________________________________________________________________________
.CheckLeft:
@ 楤 ஢     
	push	{r0-r7,LR}
	bl	.GetMapAddr
	mov	r4,r0		@     r0
	bl	.GetHeroYAdr    @ 㧨 न 
	ldrb	r1,[r2]
	bl	.GetHeroXAdr    @ 㧨 न 	
	ldrb	r0,[r2]
@ ⥯ 室 ᫨  室 ᫥    
	sub	r0,#1           @ =Hero_y*x_size+(Hero_x-1)
	mov	r3,r0		@ ࠭塞 r0  r3    न
	mov	r2,#x_size      
	mul	r1,r2
	add	r1,r0		
	mov	r2,r4		@  
	add	r2,r1		@ 饭   ஢ન
	ldrb	r5,[r2]		@ 㧨  쥪

	cmp	r5,#1		@ ᫨  ࠢ,   
	beq	_MoveLeft
	cmp	r5,#4		@ ᫨  ⮥  
	beq	_MoveLeft
	cmp	r5,#5		@ ᫨     
	beq	_MoveLeft	
	cmp	r5,#8		@ ᫨   ଠ
	beq	_MoveLeft
	cmp	r5,#9		@ ᫨   
	beq	_MoveLeft
	cmp	r5,#0		@ ᫨  
	beq	_CheckBold
	b	_NoMoveLeft
_CheckBold:
	sub	r2,#1		@   室  ?
	ldrb	r1,[r2]		@ 㧨 쥪
	cmp	r1,#4		@ ᫨ ⠬ ⮥     
	beq	_MoveBold
	b	_NoMoveLeft
_MoveBold:
	mov	r1,#0		@ 
	strb	r1,[r2]		@ ⠭
_MoveLeft:
@  室  ஥  , 㢥 Y 
@ ஢    
	bl	.Draw_Zero	@ ࠥ ண 
	mov	r4,r5		@  ஢ન  
	bl	.GetHeroXAdr    @ 㧨 न 	
	strb	r3,[r2]		@  न  ⠭

	bl	.SetHeroToMap	@ ⠭    

	cmp	r4,#5		@ ᫨  -⠪  , 稪 +1
	bne	_ScoreLeft
	bl	.IncAlmaz	@ 稢 稪 
	mov	r4,#AlmazScore	@  
	bl	.IncScores
	b	_NoMoveLeft
_ScoreLeft:
	cmp	r4,#1		@  뫠 ࠢ?
	bne	_CheckExitLeft
	mov	r4,#TravaScore	@  ࠢ
	bl	.IncScores	@ ⠥ 窨
_CheckExitLeft:
	cmp	r4,#8
	beq	_VorotaLeftOk
	cmp	r4,#9
	beq	_VorotaLeftOk
	b	_NoMoveLeft
_VorotaLeftOk:
	mov	r0,#1		@ 稠 ᫥騩 ஢
	bl	.GotoNextLevel
_NoMoveLeft:
	pop	{r0-r7,PC}
@______________________________________________________________________________
@______________________________________________________________________________
.CheckRight:
@ 楤 ஢     ࠢ
	push	{r0-r7,LR}
	bl	.GetMapAddr
	mov	r4,r0		@     r0
	bl	.GetHeroYAdr    @ 㧨 न 
	ldrb	r1,[r2]
	bl	.GetHeroXAdr    @ 㧨 न 	
	ldrb	r0,[r2]
@ ⥯ 室 ᫨  室 ࠢ    

	add	r0,#1           @ =Hero_y*x_size+(Hero_x+1)
	mov	r3,r0		@ ࠭塞 r0  r3    न
	mov	r2,#x_size      
	mul	r1,r2
	add	r1,r0		
	mov	r2,r4		@  
	add	r2,r1		@ 饭   ஢ન
	ldrb	r5,[r2]		@ 㧨  쥪

	cmp	r5,#1		@ ᫨  ࠢ,   
	beq	_MoveRight
	cmp	r5,#4		@ ᫨  ⮥  
	beq	_MoveRight
	cmp	r5,#5		@ ᫨     
	beq	_MoveRight	
	cmp	r5,#8		@ ᫨   ଠ
	beq	_MoveRight
	cmp	r5,#9		@ ᫨   
	beq	_MoveRight
	cmp	r5,#0		@ ᫨  
	beq	_CheckBoldR
	b	_NoMoveRight
_CheckBoldR:
	add	r2,#1		@   室  ࠢ?
	ldrb	r1,[r2]		@ 㧨 쥪
	cmp	r1,#4		@ ᫨ ⠬ ⮥     
	beq	_MoveBoldR
	b	_NoMoveRight
_MoveBoldR:
	mov	r1,#0		@ 
	strb	r1,[r2]		@ ⠭
_MoveRight:
@  室  ஥  , 㢥 Y 
@ ஢    
	bl	.Draw_Zero	@ ࠥ ண 
	mov	r4,r5		@  ஢ન  	
	bl	.GetHeroXAdr    @ 㧨 न 	
	strb	r3,[r2]		@  न  ⠭

	bl	.SetHeroToMap	@ ⠭    

	cmp	r4,#5		@ ᫨  -⠪  , 稪 +1
	bne	_ScoreRight
	bl	.IncAlmaz	@ 稢 稪 
	mov	r4,#AlmazScore	@  
	bl	.IncScores
	b	_NoMoveRight
_ScoreRight:
	cmp	r4,#1		@  뫠 ࠢ?
	bne	_CheckExitRight
	mov	r4,#TravaScore	@  ࠢ
	bl	.IncScores	@ ⠥ 窨
_CheckExitRight:
	cmp	r4,#8
	beq	_VorotaRightOk
	cmp	r4,#9
	beq	_VorotaRightOk
	b	_NoMoveRight
_VorotaRightOk:
	mov	r0,#1		@ 稠 ᫥騩 ஢
	bl	.GotoNextLevel
_NoMoveRight:
	pop	{r0-r7,PC}
@______________________________________________________________________________

@______________________________________________________________________________
.GotoNextLevel:
@ 楤  १㦠 ⥪騩 ஢ : r0=0;
@  ॡ뢠   ᫥騩 ஢ : r0=1;
@  ⠪ ஢  稫   (  ஢   ):)
	push	{r0-r7,LR}
	mov	r2,r0		@ ࠭塞 r0  r2
	mov	r0,#35
	push	{r0-r7}
	@@bl	.MelodyPlay	@ ࠥ  砭 ஢
	pop	{r0-r7}
	bl	.GetLevelAddr	@ 砥  ६ ஢
	mov	r3,r0
	ldr	r0,[r3]		@ 㧨
	cmp	r2,#0		@  㦭 ⥪騩 ஢ ?
	bne	_NextLevel
	bl	.GetLifeAdr	@  ६  ﬨ  r4
	ldrb	r1,[r4]		@ 㧨
	sub	r1,#1		@ 訫 - 
	cmp	r1,#0		@  稫?
	bne	_NextLife       @ ᫨  稫 稭  ᭠砫
	mov	r1,#3		@  ᭮ 3
	mov	r0,#0		@ ஢ ᭮ 
_NextLife:
	str	r1,[r4]		@ ࠭ - 
	b	_ContinueGame
_NextLevel:
	add	r0,#1		@ 騩 ஢
	cmp	r0,#MaxLevelNum @  ⠪ ஢    ன?
	bne	_ContinueGame
	mov	r0,#0		@  稭  ᭠砫
_ContinueGame:
	str	r0,[r3]		@ ࠭  ஢
	bl	.LoadMap	@ 㧨   r0 ஢
_Exitlevel:
	pop	{r0-r7,PC}
@______________________________________________________________________________

@_____________________________________________________________________________
.Draw_Zero: @ 楤      ⮬
	push	{r0-r2,LR}
	bl	.GetHeroYAdr    @ 㧨 न 
	ldrb	r1,[r2]
	bl	.GetHeroXAdr    @ 㧨 न 	
	ldrb	r0,[r2]
			        @ =Hero_y*X_size+Hero_x
	mov	r2,#x_size      
	mul	r1,r2
	add	r1,r0		
	bl	.GetMapAddr     @    r0
	add	r0,r1		@ 饭   ஢ન
	mov	r1,#4		@ ⮥ 
	strb	r1,[r0]
	pop	{r0-r2,PC}
@_____________________________________________________________________________

@______________________________________________________________________________
.DrawMapXY:
@ 楤   ࠭   
	push	{r0-r7,LR}
	bl	.GetMapXY
	mov	r2,r0		@ ࠭塞 r0  r2
	bl	.GetMapAddr     @    r0
	mov	r4,r0
	mov	r0,r2      	@ ⭮  r0
	mov	r2,#x_size
	mul	r1,r2		@ 㪠⥫=y*x_size+x
	add	r1,r0		@ 㪠⥫  
	add	r4,r1		@ ⥯ 㪠⥫ ⮨  㦭   

	mov	r2,#12          @ न  ࠭ y
_next_y:
	mov	r1,#0		@ न  ࠭ x
_next_x:
	ldrb	r3,[r4]		@ ⠥   -稫  쥪
	mov	r0,#ObjSize
	mul	r3,r0		@ 稫 ᬥ饭 㦭 쥪  ᨢ 쥪⮢
	bl	.GetObjAdr      @  ᨢ ꥪ⮢
        bl	.PaintBMP	@ 㥬 쥪  ࠭
	add	r1,#8		@ न   ࠭+8
	add	r4,#1		@ ᫥騩   
	cmp	r1,#View_x	@    ࠭?
	bne	_next_x		@ ᫥騩 쥪
	add	r4,#x_size	@ 㪠⥫ = x_size-View_size_x-1
	sub	r4,#View_size_x
	add	r2,#8		@  y  8 ᥫ  㥬
	cmp	r2,#View_y
	bne	_next_y		@  㥬

	pop	{r0-r7,PC}
@______________________________________________________________________________

@______________________________________________________________________________
.SetHeroToMap:	@⠭   
	push {r0-r2,lr}	
	bl	.GetHeroYAdr    @ 㧨 न 
	ldrb	r1,[r2]
	bl	.GetHeroXAdr    @ 㧨 न 
	ldrb	r0,[r2]

	mov	r2,#x_size      @ =Hero_y*X_size+Hero_x
	mul	r1,r2
	add	r1,r0		
	bl	.GetMapAddr     @  
	add	r0,r1		@ 饭   ᠤ 
	mov	r1,#2
	strb	r1,[r0]		@ ⠢  
	pop     {r0-r2,pc}
@______________________________________________________________________________

@_______________________________________________________________________________
.LoadMap:  
@ 楤 㦠 㦭     樠
@  室 ६
@  ॡ㥬  ।  r0 ( ࢮ  - 0)
	push	{r0-r7,LR}	
	mov	r4,r0		@   㦭 
	bl	.GetMapsAdr	@ 砥  ࢮ   r0
	mov	r1,#x_size
	mov	r2,#y_size
	mul	r1,r2		@ 稫 ࠧ   ( 㦥)
	add	r1,#20		@  ⮫쪮  㦥
	mul	r4,r1		@ 稫 ᬥ饭  㦭   
	add	r0,r4		@  ⥯ 稫  㦭  
@  室 㧨 㦥 
@  r0   ࢮ  㦥
	mov	r3,r0		@ ࠭ 
	ldrh	r2,[r3,#0]	@ 㧨 ६ 
	bl	.GetTimeAdr
	str	r2,[r0]		@ ࠭ ६ 
	ldrh	r2,[r3,#2]	@ 㧨   
	bl	.GetMapAlmazAdr
	str	r2,[r0]		@ ࠭
	add	r3,#4		@    ।
	ldrb	r0,[r3]		@ 㧨  न 
	bl	.GetHeroXAdr	@ 稫  न    r2
	strb	r0,[r2]		@ ᠫ
	add	r3,#1		@ ᫥騩  - Y न 
	ldrb	r0,[r3]		@ 㧨 Y
	bl	.GetHeroYAdr	@ 稫  न Y   r2
	strb	r0,[r2]		@ ᠫ
	add	r3,#1		@ 室  न⠬  ᬮ
	ldrb	r0,[r3]		@ 㧨 
	add	r3,#1		@ 騩 
	ldrb	r2,[r3]		@ 㧨 Y
	mov	r4,r1		@ ࠭塞 r1
	mov	r1,r2		@  맮 SaveMapXY  㦭 r0,r1
	bl	.SaveMapXY	@ ࠭塞 न  ᬮ

	add	r3,#13		@ ய᪠ १ࢨ஢ 
@  㧨
@  室 ᪮஢ ࠭   ࠡ 
	mov	r2,r3
	bl	.GetMapAddr	@ 稫  ࠡ祩 
	sub	r4,#20		@  㦭 1500  ᪮஢  ⥪ 
_NextByteCopy:
	ldrb	r3,[r2]		@ ⠫  
	strb	r3,[r0]		@ ᠫ  ࠡ 
	add	r2,#1           @ 騩 
	add	r0,#1		@ 騩 
	sub	r4,#1		@
	cmp	r4,#0		@ ?
	bne	_NextByteCopy

@ ⠭   襣 
	bl	.SetHeroToMap
	bl	.GetAlmazAdr	@ 㫨 稪 
	mov	r1,#0
	str	r1,[r0]		@ ᠫ
	bl	.GetExitAdr	@ 㫨 䫠  
	str	r1,[r0]		@ ᠫ
	bl	.GetDeadAdr	@ 砥  䫠 ᬥ	
	mov	r1,#0		@ ⨬ 䫠 ᬥ
	str	r1,[r0]		@ ᠫ 祭
	mov	r0,#3		@  梥
	bl	.clrscr         @ ⨫ ࠭
	bl	.DrawRHoST	@   墠... ;)
	pop     {r0-r7,pc}
@_______________________________________________________________________________

@______________________________________________________________________________
.DecTime:	 
@ 楤 㬥蠥 稪 ६  ᫨  - 㡨 
	push	{r0-r7,LR}
	bl	.GetCountAdr	@ 稫  ⥫ ६
	ldr	r1,[r0]		@ 㧨 祭
	add	r1,#1		@ ਡ 
	str	r1,[r0]
	cmp	r1,#8		@  㦥 8?
	bne	_NextDiv	@    ⠫ -  ᫥饣 ࠧ
	mov	r1,#0           @ ⥫ ࠢ ⥯ 
	str	r1,[r0]		@ ᠫ  ⭮  
	bl	.GetTimeAdr	@ 稫  ६  ⠩஬
	ldr	r1,[r0]		@ 㧨 祭
	sub	r1,#1		@ 訫
	str	r1,[r0]		@ ᠫ
	cmp	r1,#50		@  50 ᥪ㭤?
	bne	_CheckOver
	bl	.DrawSergPol	@  䨪
_CheckOver:
	cmp	r1,#0		@  ६ 砩  稫?
	bne	_NextDiv	@  - த
	mov	r0,#52		@  ६ 稫
	push	{r0-r7}
	@@bl	.MelodyPlay
	pop	{r0-r7}
	bl	_DrawDeath	@  㬥 - 㥬 ᨢ ᬥ
_NextDiv:
	pop     {r0-r7,pc}
@______________________________________________________________________________

@______________________________________________________________________________
.DrawState: @ 楤  ப ﭨ (稪 ,६  .)
	push	{r0-r7,LR}

	bl	.GetDeadAdr	@  䫠 ᬥ  r0
	ldr	r0,[r0]
	cmp	r0,#0xFF	@  ?
	bne	_DrawState
	bl	.GetLifeAdr	@  稪   r4
	ldr	r0,[r4]		@ 㧨	
	cmp	r0,#1		@ ᫨ -  1,  GAME OVER
	bne	_DrawState
@ 㥬 BMP - Game Over
	bl	.DrawGameOver
	b	_DontDraw
_DrawState:
	bl	.GetAlmazAdr	@ 稪 
	ldr	r0,[r0]		@ ⠫
	mov	r4,#0		@ न   뢮
	mov	r5,#1		@ न Y  뢮	
	bl	.Write3NumXY	@ ⮡ࠦ  ࠭

	mov	r1,#11		@  न 
	mov	r2,#0		@  न Y
	mov	r3,#5		@   稪  ᪮쪮  ᮡ
	mov	r0,#ObjSize
	mul	r3,r0		@ 稫 ᬥ饭 㦭 쥪  ᨢ 쥪⮢
	bl	.GetObjAdr      @  ᨢ ꥪ⮢
        bl	.PaintBMP	@ 㥬 쥪  ࠭

	bl	.GetMapAlmazAdr	@ 쪮 ᥣ  ᮡ ?
	ldr	r0,[r0]		@ 㧨
	mov	r4,#19		@ न 
	mov	r5,#1		@ न Y
	bl	.Write3NumXY	@ ⮡ࠦ  ࠭

	mov	r1,#34		@  न 
	mov	r2,#0		@  न Y
	mov	r3,#10		@ 쪨 ᨪ
	mov	r0,#ObjSize
	mul	r3,r0		@ 稫 ᬥ饭 㦭 쥪  ᨢ 쥪⮢
	bl	.GetObjAdr      @  ᨢ ꥪ⮢
        bl	.PaintBMP	@ 㥬 쥪  ࠭
	
	bl	.GetTimeAdr	@ 稫  ६ ६
	ldr	r0,[r0]		@ ⠫
	mov	r4,#42		@ न   뢮
	mov	r5,#1		@ न Y  뢮	
	bl	.Write3NumXY

	bl	.DrawMan	@ 㥬 祫窠 㬥襭 ࠧ  STATUS	

	mov	r1,#66		@ न 
	mov	r2,#1	        @ न Y
	bl	.GetLifeAdr	@ 稫  ६  
	ldr	r0,[r4]		@ 祭
	bl	.WriteNum	@ 뢮

	adr	r0,Scores	@ 窨
	ldr	r0,[r0]		@ ⠫
	mov	r4,#75		@ न   뢮
	mov	r5,#1		@ न Y  뢮	
	bl	.WriteBigNumXY
_DontDraw:
	pop     {r0-r7,pc}
@______________________________________________________________________________

@______________________________________________________________________________
.IncScores: 
@ 楤 ந  窮 ࠭      窠 
@ - 窮 室   ।  r4
	push	{r0-r7,LR}
	
	adr	r1,Scores	@ 窨
	ldr	r0,[r1]		@ ⠫
	add	r0,r4		@ ਡ 窨
	str	r0,[r1]		@ ᠫ ⭮

	pop     {r0-r7,pc}
@______________________________________________________________________________


@______________________________________________________________________________
.WriteBigNumXY:			
@ 뢮  ࠭     न⠬  r4-x  r5-y
	push	{r0-r7,LR}
	cmp	r0,#0
	blt	_NoWrite
	ldr	r1,TenThous
	bl	.divmod
	mov	r3,r1
	mov	r1,r4
	mov	r2,r5
	bl	.WriteNum
	mov	r0,r3
	ldr	r1,Thous
	bl	.divmod
	mov	r3,r1
	add	r4,#4           @  न  
	mov	r1,r4
	bl	.WriteNum
	mov	r0,r3
	mov	r1,#100
	bl	.divmod
	mov	r3,r1
	add	r4,#4		@  न  
	mov	r1,r4
	bl	.WriteNum
	mov	r0,r3
	mov	r1,#10
	bl	.divmod
	mov	r3,r1
	add	r4,#4		@  न  
	mov	r1,r4
	bl	.WriteNum
	mov	r0,r3
	add	r4,#4
	mov	r1,r4
	bl	.WriteNum
_NoWrite:
	pop	{r0-r7,PC}

.align 2
TenThous: .word 10000
Thous:	  .word	 1000
@______________________________________________________________________________
@______________________________________________________________________________
.Write3NumXY:
@ 뢮  ࠭  (3 樨)   न⠬  r4-x  r5-y
	push	{r0-r7,LR}
	mov	r2,r5
	cmp	r0,#0
	blt	_NoWrite3
	mov	r1,#100
	bl	.divmod
	mov	r3,r1
	mov	r1,r4
	bl	.WriteNum
	mov	r0,r3
	mov	r1,#10
	bl	.divmod
	mov	r3,r1
	add	r4,#4		@  न  
	mov	r1,r4
	bl	.WriteNum
	mov	r0,r3
	add	r4,#4
	mov	r1,r4
	bl	.WriteNum
_NoWrite3:
	pop	{r0-r7,PC}
@______________________________________________________________________________


@______________________________________________________________________________
.CheckViewMove:  @ ஢ਬ 㦭    ᬮ
	push	{r0-r7,LR}
	bl	.GetMapXY	@ 砥 न 
@  r0 室   ᬮ,   r1 - y  ᬮ
@ ஢ਬ 㦭    ᬮ 
	cmp	r0,#0
	beq	_CheckRight
	bl	.GetHeroXAdr    @ 㧨  ६ X न 
	ldrb	r2,[r2]		@㦠 祭 hero_x
	mov	r3,r0
	add	r3,#4           @   ࠭ 4
	cmp	r2,r3		@ ᫨ hero_x<(x+3)
	bgt	_CheckRight
	sub	r0,#1  		@   ᬮ 

_CheckRight:
				@if x<>(x_Size-View_size_x-1)
	mov	r2,#x_size	
	sub	r2,#View_size_x
	cmp	r0,r2
	beq	_CheckUp
	bl	.GetHeroXAdr    @ 㧨  ६ X न 
	ldrb	r2,[r2]		@㦠 祭 hero_x
	mov	r3,r0		@
	add	r3,#View_size_x-4   @   ࠭ 4
	cmp	r2,r3		@ if hero_x>(x+view_size_x-4)
	blt	_CheckUp
	add	r0,#1  		@   ᬮ ࠢ
_CheckUp:
	cmp	r1,#0           @if y<>0
	beq	_CheckDown
	bl	.GetHeroYAdr    @ 㧨  ६ Y न 
	ldrb	r2,[r2]		@㦠 祭 hero_y
	mov	r3,r1
	add	r3,#4           @   ࠭ 4
	cmp	r2,r3		@ ᫨ hero_y<(y+3)
	bgt	_CheckDown
	sub	r1,#1  		@   ᬮ 
_CheckDown:
				@if y<>(y_Size-View_size_y-1)
	mov	r2,#y_size	
	sub	r2,#View_size_y
	cmp	r1,r2
	beq	_NoMoveView
	bl	.GetHeroYAdr    @ 㧨  ६ Y न 
	ldrb	r2,[r2]		@㦠 祭 hero_y
	mov	r3,r1
	add	r3,#View_size_y-4   @   ࠭ 4
	cmp	r2,r3		@ if Hero_y>(y+view_size_y-4)
	blt	_NoMoveView
	add	r1,#1  		@   ᬮ ࠢ
_NoMoveView:
	bl	.SaveMapXY	@ ࠭塞 न   ६ map_x  map_y

	pop     {r0-r7,pc}
@______________________________________________________________________________

@______________________________________________________________________________
.MapLife:	
@ 楤    ।  ,   .
@ 뢠 楤 MapLifeStroka  筮 ࠡ⪨
	push	{r0-r7,LR}
	adr	r0,maplife_y	@  ६ ࠭饩  ப  y
	ldrb	r1,[r0]		@ 㦠 祭
	bl	.MapLifeStroka 	@ 뢠 ࠡ  ப
	add	r1,#1		@  ப
	cmp	r1,#y_size	@  ப ᤥ?
	bne	_NextString
	mov	r1,#0		@   ᭠砫
_NextString:
	strb	r1,[r0]		@ 뢠  ६
	pop     {r0-r7,pc}
@______________________________________________________________________________

@______________________________________________________________________________
.MapLifeStroka:  
@ 楤   ப   ।  ,   .
@  r1 ।  ப  Y  ᥩ 㦭 ࠡ
	push	{r0-r4,LR}
	mov	r3,#x_size	@ ⮢ ॣ  ஢ન 砭 ப
	mul	r1,r3		@ Y*x_size
	bl	.GetMapAddr     @    r0
	add	r0,r1		@ 砥   ண 㦭  ࠡ
_NextMapObj:
        mov	r4,r0
	bl	.GetExitAdr
	ldrb	r1,[r0]		@ 㦠 祭
	mov	r0,r4
	cmp	r1,#0xFF	@  ?
	bne	_CheckBoldDown	@ -   ஢ 쥪
	ldrb	r1,[r0]		@ 㦠 ⥪騩 쥪
	cmp	r1,#8		@   室(ଠ)?
	bne	_CheckExitInv	@ ᫨   ஢塞 
	mov	r1,#9		@ 㦠 
	strb	r1,[r0]		@ ⥯   
	b	_CheckBoldDown
_CheckExitInv:
	cmp	r1,#9		@   室()?
	bne	_CheckExitClose
	mov	r1,#8		@ ⥯  ଠ 
	strb	r1,[r0]		@ ᠫ
	b	_CheckBoldDown
_CheckExitClose:
	cmp	r1,#7		@   ?
	bne	_CheckBoldDown
	mov	r1,#8		@ ⥯    
	strb	r1,[r0]
_CheckBoldDown:
	ldrb	r1,[r0]		@ 㦠 ⥪騩 쥪
	cmp	r1,#0		@  ?
	bne	_CheckBoldLeft
	mov	r2,r0
	add	r2,#x_size	
	ldrb	r1,[r2]         @ 㦠 쥪 室騩 אַ  
	cmp	r1,#4           @    ᢮?
	bne	_CheckBoldLeft
	strb	r1,[r0]		@    ⮥ 
	mov	r1,#0		@ 
	strb	r1,[r2]		@   ⮣  - 
	add	r2,#x_size	@ ஢ਬ  ⮨     ?
	ldrb	r1,[r2]
	cmp	r1,#2		@  祫?
	beq	_MapDrawDeath
	bl	_NextCheckMap
_MapDrawDeath:
	bl	_DrawDeath	@  㬥 - 㥬 ᨢ ᬥ
_CheckBoldLeft:
@  ஢ਬ    㯠 
	ldrb	r1,[r0]		@ 㦠 ⥪騩 쥪
	cmp	r1,#0		@  ?
	bne	_CheckBoldRight
	mov	r2,r0
	sub	r2,#1		@ ஢ਬ  ᫥ ⮥ 
	ldrb	r1,[r2]		@ 㦠 ⥪饥 祭
	cmp	r1,#4		@  ᢮?
	bne	_CheckBoldRight
	add	r2,#x_size	@   
	ldrb	r1,[r2]         @ 㦠
	cmp	r1,#4		@ ᢮?
	bne	_CheckBoldRight
	add	r2,#1		@ ஢ਬ   ⮨   ࠢ
	ldrb	r1,[r2]		@ 㦠
	cmp	r1,#1		@  ࠢ ⮨?
	beq	_CheckBoldRight @ ᫨ ,  室
	cmp	r1,#2		@ ஢ਬ   ⮨    祫
	beq	_CheckBoldRight	@ ᫨ ,  室
	mov	r1,#4		
	strb	r1,[r0]		@    ⮥ 
	mov	r1,#0		@ 
	sub	r2,#1
	strb	r1,[r2]		@   ⮣  - 
	add	r2,#x_size	@ ஢ਬ  ⮨     ?
	ldrb	r1,[r2]
	cmp	r1,#2		@  祫?
	bne	_NextCheckMap
	bl	_DrawDeath	@  㬥 - 㥬 ᨢ ᬥ
	b	_NextCheckMap
_CheckBoldRight:
@  ஢ਬ    㯠 ࠢ
	ldrb	r1,[r0]		@ 㦠 ⥪騩 쥪
	cmp	r1,#0		@  ?
	bne	_CheckAlmazDown
	mov	r2,r0
	add	r2,#1		@ ஢ਬ  ࠢ ⮥ 
	ldrb	r1,[r2]		@ 㦠 ⥪饥 祭
	cmp	r1,#4		@ ࠢ ᢮?
	bne	_CheckAlmazDown
	add	r2,#x_size	@ ࠢ  
	ldrb	r1,[r2]         @ 㦠
	cmp	r1,#4		@ ᢮?
	bne	_CheckAlmazDown
	sub	r2,#1		@ ஢ਬ   ⮨   ࠢ
	ldrb	r1,[r2]		@ 㦠
	cmp	r1,#1		@  ࠢ ⮨?
	beq	_CheckAlmazDown @ ᫨ ,  室
	cmp	r1,#2		@ ஢ਬ   ⮨    祫
	beq	_CheckAlmazDown	@ ᫨ ,  室
	mov	r1,#4		
	strb	r1,[r0]		@    ⮥ 
	mov	r1,#0		@ 
	add	r2,#1
	strb	r1,[r2]		@   ⮣  - 
	add	r2,#x_size	@ ஢ਬ  ⮨     ?
	ldrb	r1,[r2]
	cmp	r1,#2		@  祫?
	bne	_NextCheckMap
	bl	_DrawDeath	@  㬥 - 㥬 ᨢ ᬥ
	b	_NextCheckMap
_CheckAlmazDown:
	ldrb	r1,[r0]		@ 㦠 ⥪騩 쥪
	cmp	r1,#5		@  ?
	bne	_CheckAlmazRight
	mov	r2,r0
	add	r2,#x_size	
	ldrb	r1,[r2]         @ 㦠 쥪 室騩 אַ  
	cmp	r1,#4           @    ᢮?
	bne	_CheckAlmazRight
	strb	r1,[r0]		@    ⮥ 
	mov	r1,#5		@ 
	strb	r1,[r2]		@   ⮣  - 
	add	r2,#x_size	@ ஢ਬ  ⮨     ?
	ldrb	r1,[r2]
	cmp	r1,#2		@  祫?
	bne	_NextCheckMap
	bl	_DrawDeath	@  㬥 - 㥬 ᨢ ᬥ
	b	_NextCheckMap
_CheckAlmazRight:
@  ஢ਬ    㯠 ࠢ
	ldrb	r1,[r0]		@ 㦠 ⥪騩 쥪
	cmp	r1,#5		@  ?
	bne	_CheckAlmazLeft
	mov	r2,r0
	add	r2,#1		@ ஢ਬ  ᯠ ⮥ 
	ldrb	r1,[r2]		@ 㦠 ⥪饥 祭
	cmp	r1,#4		@ ࠢ ᢮?
	bne	_CheckAlmazLeft
	add	r2,#x_size	@ ࠢ  
	ldrb	r1,[r2]         @ 㦠
	cmp	r1,#4		@ ᢮?
	bne	_CheckAlmazLeft
	sub	r2,#1		@ ஢ਬ   ⮨   ࠢ
	ldrb	r1,[r2]		@ 㦠
	cmp	r1,#1		@  ࠢ ⮨?
	beq	_CheckAlmazLeft @ ᫨ ,  室
	cmp	r1,#2		@ ஢ਬ   ⮨    祫
	beq	_CheckAlmazLeft	@ ᫨ ,  室
	mov	r1,#4		
	strb	r1,[r0]		@    ⮥ 
	mov	r1,#5		@ 
	add	r2,#1
	strb	r1,[r2]		@   ⮣  - 
	add	r2,#x_size	@ ஢ਬ  ⮨     ?
	ldrb	r1,[r2]
	cmp	r1,#2		@  祫?
	bne	_NextCheckMap
	bl	_DrawDeath	@  㬥 - 㥬 ᨢ ᬥ
	b	_NextCheckMap
_CheckAlmazLeft:
@  ஢ਬ    㯠 
	ldrb	r1,[r0]		@ 㦠 ⥪騩 쥪
	cmp	r1,#5		@  ?
	bne	_NextCheckMap
	mov	r2,r0
	sub	r2,#1		@ ஢ਬ  ᫥ ⮥ 
	ldrb	r1,[r2]		@ 㦠 ⥪饥 祭
	cmp	r1,#4		@  ᢮?
	bne	_NextCheckMap
	add	r2,#x_size	@   
	ldrb	r1,[r2]         @ 㦠
	cmp	r1,#4		@ ᢮?
	bne	_NextCheckMap
	add	r2,#1		@ ஢ਬ   ⮨   ࠢ
	ldrb	r1,[r2]		@ 㦠
	cmp	r1,#1		@  ࠢ ⮨?
	beq	_NextCheckMap	@ ᫨ ,  室
	cmp	r1,#2		@ ஢ਬ   ⮨    祫
	beq	_NextCheckMap	@ ᫨ ,  室
	mov	r1,#4		
	strb	r1,[r0]		@    ⮥ 
	mov	r1,#5		@ 
	sub	r2,#1
	strb	r1,[r2]		@   ⮣  - 
	add	r2,#x_size	@ ஢ਬ  ⮨     ?
	ldrb	r1,[r2]
	cmp	r1,#2		@  祫?
	bne	_NextCheckMap
	bl	_DrawDeath	@  㬥 - 㥬 ᨢ ᬥ
	b	_NextCheckMap
_NextCheckMap:
	add	r0,#1		@ 騩 쥪
	sub	r3,#1
	cmp	r3,#0
	beq	_ExitMapLife
	bl	_NextMapObj
_ExitMapLife:
	pop     {r0-r4,pc}
@______________________________________________________________________________

@______________________________________________________________________________
_DrawDeath:     @ 楤  ᨢ ᬥ 祫
	push	{r0-r7,LR}
	bl	.GetMapAddr
	mov	r4,r0		@     r0
	bl	.GetHeroYAdr    @ 㧨 न 
	ldrb	r1,[r2]
	bl	.GetHeroXAdr    @ 㧨 न 	
	ldrb	r0,[r2]
@ ⥯ 室 㭨⮦ ᠬ     室
@ ᫥,ࠢ,᭨,ᢥ  
			        @ =Hero_y*X_size+Hero_x
	mov	r3,r1		@ ࠭塞 r1  r3    न
	mov	r2,#x_size      
	mul	r1,r2
	add	r1,r0		
	mov	r2,r4		@  
	add	r2,r1		@ 饭   ஢ન ⥯  r2

	mov	r3,#11		@ 㭮 
	bl	.DrawBoom	@ 㥬   9 

@  - ன 㬥  㭥  ᮡ 9 ⥩ ࠭⢠! ;)
	bl	.GetDeadAdr	@ 砥  䫠 ᬥ	
	mov	r1,#0xFF
	str     r1,[r0]		@ ⠭ 䫠 ᬥ
	pop     {r0-r7,pc}
@______________________________________________________________________________
@______________________________________________________________________________
.DrawBoom:		@ 㭪    9 
@ r2 -      ண 㤥 
@ r3 -  쥪  ᨢ 쥪⮢  㤥 ᮢ뢠  뢥
	push	{r0-r3,LR}
	strb    r3,[r2]		@ ᠫ  
	sub	r2,#1		@ 
	strb    r3,[r2]		@ ᠫ 
	add	r2,#2		@ ࠢ
	strb    r3,[r2]		@ ᠫ
	add	r2,#x_size	@ ࠢ 
	strb    r3,[r2]		@ ᠫ
	sub	r2,#1	 	@  ஥
	strb    r3,[r2]		@ ᠫ
	sub	r2,#1		@  
	strb    r3,[r2]		@ ᠫ
	sub	r2,#x_size*2	@  
	strb    r3,[r2]		@ ᠫ
	add	r2,#1		@  ஥
	strb    r3,[r2]		@ ᠫ
	add	r2,#1		@ ࠢ 
	strb    r3,[r2]		@ ᠫ
	pop     {r0-r3,pc}
@______________________________________________________________________________

@______________________________________________________________________________
.GetMapXY:	@ 楤 頥 न   r0  r1 
	push	{LR}
	adr	r0,map_x	@ x 
	ldr	r0,[r0]		@ ⠫
	adr	r1,map_y        @ y 
	ldr	r1,[r1]         @ ⠫
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.SaveMapXY:	@ 楤  न   ६ map_x  map_y
	push	{r0-r2,LR}
	adr	r2,map_x	@ x 
	str	r0,[r2]		@ ᠫ
	adr	r2,map_y        @ y 
	str	r1,[r2]         @ ᠫ
	pop	{r0-r2,PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetHeroXAdr:	@ 楤 頥  न    r2
	push	{LR}
	adr	r2,hero_x	@ x 
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetHeroYAdr:	@ 楤 頥  न Y   r2
	push	{LR}
	adr	r2,hero_y	@ y 
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetObjAdr:	@ 楤 頥  ᨢ ꥪ⮢  r0
	push	{LR}
	adr	r0,Obj		
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.IncAlmaz:	
@ 楤 㢥稢 稪 ,஢    ᮡ࠭
	push	{r0-r7,LR}
	bl	.GetAlmazAdr
	ldr	r1,[r0] 	@ 㦠 祭 
	add	r1,#1		@ +  
	str	r1,[r0]		@ 뢠 ⭮  ६
@ ⥯ ஢ਬ   ᮡࠫ 㦭    ᫮ 
	bl	.GetMapAlmazAdr	@ 稫 
	ldr	r2,[r0]		@ ⠫ 祭
	cmp	r1,r2		@   ᮡ࠭?
	bne	_Malo
	mov	r0,#25
	push	{r0-r7}
	@@bl	.MelodyPlay
	pop	{r0-r7}
	bl	.GetExitAdr	@ 砥  䫠 ࠧ襭 室
	mov	r1,#0xFF        @ 室 ࠧ襭
	str	r1,[r0]		@
_Malo:
	pop	{r0-r7,PC}
@______________________________________________________________________________

@______________________________________________________________________________
.GetAlmazAdr:	@ 楤 頥  ६  ࠭   r0
	push	{LR}
	adr	r0,almaz
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetDirectAdr:	@ 楤 頥  ६  ࠭   r0
	push	{LR}
	adr	r0,direct
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetTimeAdr:	
@ 楤 頥  ६  ࠭ ६ map_time
	push	{LR}
	adr	r0,map_time
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetCountAdr:
@ 楤 頥  ६  ࠭ ⥫ ६ time_count
	push	{LR}
	adr	r0,time_count
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetMapAlmazAdr:
@ 楤 頥  ६  ࠭ ⢠ 
@   㦭 ᮡ     r0
	push	{LR}
	adr	r0,map_almaz
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetExitAdr:	
@ 楤 頥  ६  ࠭ 䫠 室  r0
	push	{LR}
	adr	r0,exit_flag
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetLevelAddr: 
@ 楤 頥  ६ ࠭饩  ⥪饣 ஢  r0
	push	{LR}
	adr	r0,Level_Num		@ ६ ஢
	pop	{PC}
@______________________________________________________________________________

@______________________________________________________________________________
.GetLifeAdr:	@ 稫  ६  , 頥  r4
	push	{LR}
	adr	r4,Lifes		@ ६ - 
	pop	{PC}
@______________________________________________________________________________
@______________________________________________________________________________
.GetDeadAdr:	@ 稫  䫠 ᬥ, 頥  r0
	push	{LR}
	adr	r0,HeroDead	@ 䫠 ᬥ
	pop	{PC}
@______________________________________________________________________________

@ Place any variables here
.align 4
almaz:	.word 0x0
Scores: .word 0x0
direct: .word 0x0
maplife_y: .word 0x0	@ ६  ࠭ ⥪饣 Y ࠡ⪨ 
time_count: .word 0x0	@ ⥫   ६
exit_flag: .word 0x0
Level_Num: .word 0x0	@  ஢  
Lifes:	.word 0x3	@ - 
HeroDead: .word 0x0	@  ᬥ : ᫨ FF - ன 㬥
@ 騥 ६ ।   㧪 
map_time: .word 100	@ ६  宦  (ᥪ㭤)
map_almaz: .word 1	@   ஥ 室 ᮡ
hero_x: .word 8		@ न  x
hero_y: .word 12        @ न  y
map_x:	.word 0x0	@ न  ᬮ 
map_y:	.word 0x0

@______________________________________________________________________________
.PaintBMP: 			@(bmpOffs,posX,posY,ofs) 㥬 BMP
@ r0    ᠬ BMP
@ r1 - x  r2 - y  r3-ᬥ饭  ᠬ bmp
	push	{r0-r6,LR}
	mov	r6,r0
	add	r6,#2		@ r6: dov' la bitmap vera e propria
	add	r6,r3
	ldrb	r3,[r0]		@ r3: sizeX
	ldrb	r4,[r0,#0x1]	@ r4: sizeY
	mov	r0,r1
	mov	r1,r2
	bl	.getofs		@r0: posizione a cui cominciare a disegnare
	mov	r1,r6		@r1: inizio bitmap r2: pixel corrente r3=sizeX r4=sizeY
_nextRow:
	mov	r5,#0
_nextPixel:
	ldrb	r2,[r1]
	cmp	r2,#3		@per fare le trasparenze uso colori superiori al 3
	bgt	_noPut
	strb	r2,[r0,r5]
_noPut:
	add	r5,#1
	add	r1,#1
	cmp	r5,r3
	blt	_nextPixel
	add	r0,#MaxX
	sub	r4,#1
	cmp	r4,#0
	bgt	_nextRow
	pop	{r0-r6,PC}
@______________________________________________________________________________
@______________________________________________________________________________
.align 2
.WriteNum:                   
@ r0 -    㦭 뢥
@ r1 - x  r2 - y
	push	{r0-r3,LR}
	mov	r3,#NumSize
	mul	r3,r0
	adr	r0,Numeri
	bl	.PaintBMP
	pop	{r0-r3,PC}
@______________________________________________________________________________


.equ MaxX,96
.equ MaxY,92

.equ BonusSize,6*7
.equ MaxBonus,4

.align 4
.equ NumSize,18
Numeri:
.align 2
.byte 3,6
Zero:
.byte 3,0,3
.byte 0,3,0
.byte 0,3,0
.byte 0,3,0
.byte 0,3,0
.byte 3,0,3
Uno:
.byte 3,3,0
.byte 3,0,0
.byte 3,3,0
.byte 3,3,0
.byte 3,3,0
.byte 3,3,0
Due:
.byte 3,0,3
.byte 0,3,0
.byte 3,3,0
.byte 3,0,3
.byte 0,3,3
.byte 0,0,0
Tre:
.byte 0,0,3
.byte 3,3,0
.byte 3,0,3
.byte 3,3,0
.byte 0,3,0
.byte 3,0,3
Quattro:
.byte 3,3,0
.byte 3,0,0
.byte 3,0,0
.byte 0,3,0
.byte 0,0,0
.byte 3,3,0
Cinque:
.byte 0,0,0
.byte 0,3,3
.byte 0,0,3
.byte 3,3,0
.byte 0,3,0
.byte 0,0,3
Sei:
.byte 3,0,0
.byte 0,3,3
.byte 0,0,3
.byte 0,3,0
.byte 0,3,0
.byte 3,0,3
Sette:
.byte 0,0,0
.byte 3,3,0
.byte 3,0,3
.byte 3,0,3
.byte 3,0,3
.byte 3,0,3
Otto:
.byte 3,0,3
.byte 0,3,0
.byte 3,0,3
.byte 0,3,0
.byte 0,3,0
.byte 3,0,3
Nove:
.byte 3,0,3
.byte 0,3,0
.byte 0,3,0
.byte 3,0,0
.byte 3,3,0
.byte 0,0,3

.equ x_size,50
.equ y_size,30
.equ View_x,96
.equ View_y,92
.equ View_size_x,12
.equ View_size_y,10
.equ ObjSize,64
.equ TravaScore,5
.equ AlmazScore,20

.align 4
Obj:
.align 2
.byte 8,8		@ ࠧ 쥪
@ 쥪 0 - 
.byte 3,3,3,0,0,3,3,3
.byte 3,0,0,1,1,0,0,3
.byte 3,0,2,2,1,1,0,3
.byte 0,1,2,2,1,1,1,0
.byte 0,1,1,1,1,1,1,0
.byte 3,0,1,1,1,1,0,3
.byte 3,0,0,1,1,0,0,3
.byte 3,3,3,0,0,3,3,3
@ 쥪 1 - ࠢ
.byte 2,2,2,2,2,2,2,2  
.byte 2,2,1,2,1,2,1,2
.byte 2,1,2,2,2,2,2,2
.byte 2,2,2,2,1,2,1,2
.byte 2,1,2,1,2,2,2,2
.byte 2,2,2,2,2,1,2,2
.byte 2,1,2,2,1,2,1,2
.byte 2,2,2,2,2,2,2,2
@ 쥪 2 - 祫
.byte 3,3,0,0,0,3,3,3
.byte 3,3,0,0,0,3,3,3
.byte 3,3,3,0,3,3,3,3
.byte 3,0,0,0,0,0,3,3
.byte 0,3,0,2,0,3,0,3
.byte 3,3,0,0,0,3,3,3
.byte 3,0,3,3,3,0,3,3
.byte 0,0,3,3,3,0,0,3
@ 쥪 3 - ⥭
.byte 1,1,2,1,1,1,1,1
.byte 0,0,2,0,0,0,0,0
.byte 1,1,2,1,1,1,1,1
.byte 2,2,2,2,2,2,2,2
.byte 1,1,1,1,1,2,1,1
.byte 0,0,0,0,0,2,0,0
.byte 1,1,1,1,1,2,1,1
.byte 1,1,1,1,1,2,1,1
@ 쥪 4 - ⮥ 
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,3,3,3,3,3
@ 쥪 5 - 
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,0,0,3,3,3
.byte 3,3,0,3,3,0,3,3
.byte 3,0,0,3,0,0,0,3
.byte 3,0,0,0,3,3,0,3
.byte 3,3,0,0,3,0,3,3
.byte 3,3,3,0,0,3,3,3
.byte 3,3,3,3,3,3,3,3
@ 쥪 6 -  ⢠
.byte 0,0,0,0,0,0,0,0
.byte 0,2,2,2,2,2,2,0
.byte 0,2,0,0,0,0,2,0
.byte 0,2,0,3,3,0,2,0
.byte 0,2,0,3,3,0,2,0
.byte 0,2,0,0,0,0,2,0
.byte 0,2,2,2,2,2,2,0
.byte 0,0,0,0,0,0,0,0
@ 쥪 7 -  
.byte 1,1,1,1,1,1,1,1
.byte 1,2,2,2,2,2,2,1
.byte 1,0,0,2,2,0,0,1
.byte 1,0,0,2,2,0,0,1
.byte 1,2,2,2,2,2,2,1
.byte 1,0,0,2,2,0,0,1
.byte 1,0,0,2,2,0,0,1
.byte 1,1,1,1,1,1,1,1
@ 쥪 8 -  
.byte 0,0,0,0,0,0,0,0
.byte 0,3,1,1,1,1,3,0
.byte 0,3,1,3,3,3,3,0
.byte 0,3,1,1,1,3,3,0
.byte 0,3,1,3,3,3,3,0
.byte 0,3,1,3,3,3,3,0
.byte 0,3,1,1,1,1,3,0
.byte 0,0,0,0,0,0,0,0
@ 쥪 9 -   
.byte 1,1,1,1,1,1,1,1
.byte 1,0,3,3,3,3,0,1
.byte 1,0,3,0,0,0,0,1
.byte 1,0,3,3,3,0,0,1
.byte 1,0,3,0,0,0,0,1
.byte 1,0,3,0,0,0,0,1
.byte 1,0,3,3,3,3,0,1
.byte 1,1,1,1,1,1,1,1
@ 쥪 10 - ᨪ ப ﭨ
.byte 3,3,3,3,3,3,3,3
.byte 3,3,0,0,0,0,3,3
.byte 3,0,3,1,3,3,0,3
.byte 3,0,3,1,3,3,0,3
.byte 3,0,3,1,1,1,0,3
.byte 3,0,3,3,3,3,0,3
.byte 3,3,0,0,0,0,3,3
.byte 3,3,3,3,3,3,3,3
@ 쥪 11 -  ⨯ ᬥ
.byte 3,3,3,3,3,3,3,3
.byte 3,3,3,0,0,3,3,3
.byte 3,3,3,0,0,3,3,3
.byte 3,0,0,0,0,0,0,3
.byte 3,3,3,0,0,3,3,3
.byte 3,3,3,0,0,3,3,3
.byte 3,3,3,0,0,3,3,3
.byte 3,3,3,0,0,3,3,3


.align 4
@______________________________________________________________________________
.DrawGameOver:		@ 楤 뢮  ப ﭨ  GameOver
	push	{r0-r3,LR}
	mov	r1,#22		@  न 
	mov	r2,#38		@  न Y
	mov	r3,#0		@ ᬥ饭 0
	adr	r0,GameOver
        bl	.PaintBMP	@ 㥬 쥪  ࠭
	pop	{r0-r3,PC}
@______________________________________________________________________________
.align 4
GameOver:
.align 2
.byte 52,10  @  
.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.byte 0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0
.byte 0,3,3,0,0,0,0,3,3,0,0,0,3,3,0,3,3,3,0,3,0,0,0,0,0,3,3,3,0,0,0,3,3,0,3,3,3,0,3,0,0,0,0,0,3,0,0,0,0,3,3,0
.byte 0,3,0,3,3,3,3,3,0,3,3,3,0,3,0,0,3,0,0,3,0,3,3,3,3,3,3,0,3,3,3,0,3,0,3,3,3,0,3,0,3,3,3,3,3,0,3,3,3,0,3,0
.byte 0,3,0,3,0,0,0,3,0,0,0,0,0,3,0,3,0,3,0,3,0,0,0,0,3,3,3,0,3,3,3,0,3,0,3,3,3,0,3,0,0,0,0,3,3,0,3,3,3,0,3,0
.byte 0,3,0,3,3,3,0,3,0,3,3,3,0,3,0,3,3,3,0,3,0,3,3,3,3,3,3,0,3,3,3,0,3,0,3,3,3,0,3,0,3,3,3,3,3,0,0,0,0,3,3,0
.byte 0,3,0,3,3,3,0,3,0,3,3,3,0,3,0,3,3,3,0,3,0,3,3,3,3,3,3,0,3,3,3,0,3,3,0,3,0,3,3,0,3,3,3,3,3,0,3,3,0,3,3,0
.byte 0,3,3,0,0,0,3,3,0,3,3,3,0,3,0,3,3,3,0,3,0,0,0,0,0,3,3,3,0,0,0,3,3,3,3,0,3,3,3,0,0,0,0,0,3,0,3,3,3,0,3,0
.byte 0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0
.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.align 4
@______________________________________________________________________________
.DrawSergPol:		@ 楤 뢮  ப ﭨ  SergPol
	push	{r0-r7,LR}
	mov	r1,#53		@  न 
	mov	r2,#7		@  न Y
	mov	r3,#0		@ ᬥ饭 0
	adr	r0,sergpol
        bl	.PaintBMP	@ 㥬 쥪  ࠭
	pop	{r0-r7,PC}
@______________________________________________________________________________
.align 4
sergpol:
.align 2
.byte 44,5  /* Image size*/
.byte 3,2,2,2,3,2,2,2,3,2,3,2,3,3,3,3,2,2,2,3,2,2,2,3,2,2,3,3,3,2,2,3,2,2,2,3,3,2,3,3,2,3,3,3
.byte 2,3,3,3,3,2,3,3,3,2,3,2,3,3,3,3,2,3,3,3,2,3,3,3,2,3,2,3,2,3,3,3,2,3,2,3,2,3,2,3,2,3,3,3
.byte 2,3,2,2,3,2,2,3,3,3,2,3,3,2,2,3,2,2,2,3,2,2,3,3,2,2,3,3,2,2,3,3,2,2,2,3,2,3,2,3,2,3,3,3
.byte 2,3,3,2,3,2,3,3,3,2,3,2,3,3,3,3,3,3,2,3,2,3,3,3,2,3,2,3,2,3,2,3,2,3,3,3,2,3,2,3,2,3,3,3
.byte 3,2,2,2,3,2,3,3,3,2,3,2,3,3,3,3,2,2,2,3,2,2,2,3,2,3,2,3,3,2,2,3,2,3,3,3,3,2,3,3,2,2,2,3

.align 4
@______________________________________________________________________________
.DrawMan:		@ 楤 뢮  ப ﭨ 쪮 祫
	push	{r0-r7,LR}
	mov	r1,#56		@  न 
	mov	r2,#1		@  न Y
	mov	r3,#0		@ ᬥ饭 0
	adr	r0,hurt
        bl	.PaintBMP	@ 㥬 쥪  ࠭
	pop	{r0-r7,PC}
@______________________________________________________________________________
.align 4
hurt:
.align 2
.byte 8,6  /* Image size*/
.byte 3,0,0,3,3,0,0,3
.byte 0,2,2,0,0,2,2,0
.byte 0,2,2,2,2,2,2,0
.byte 3,0,2,2,2,2,0,3
.byte 3,3,0,2,2,0,3,3
.byte 3,3,3,0,0,3,3,3

.align 4
@______________________________________________________________________________
.DrawRHoST:		@ 楤 뢮  ப ﭨ  RHoST 2003
	push	{r0-r7,LR}
	mov	r1,#54		@  न 
	mov	r2,#7		@  न Y
	mov	r3,#0		@ ᬥ饭 0
	adr	r0,rhost
        bl	.PaintBMP	@ 㥬 쥪  ࠭
	pop	{r0-r7,PC}
@______________________________________________________________________________
.align 4
rhost:
.align 2
.byte 41,5  /* Image size*/
.byte 2,2,3,3,2,3,2,3,3,3,3,3,2,2,2,3,2,2,2,3,3,2,3,3,2,3,3,2,2,3,3,3,2,3,3,3,2,3,3,2,3
.byte 2,3,2,3,2,3,2,3,3,3,3,3,2,3,3,3,3,2,3,3,2,3,2,2,3,2,3,3,3,2,3,2,3,2,3,2,3,2,3,3,2
.byte 2,2,3,3,2,2,2,3,2,2,2,3,2,2,2,3,3,2,3,3,2,3,2,3,3,2,3,3,2,3,3,2,3,2,3,2,3,2,3,2,3
.byte 2,3,2,3,2,3,2,3,2,3,2,3,3,3,2,3,3,2,3,3,2,3,2,2,3,2,3,2,3,3,3,2,3,2,3,2,3,2,3,3,2
.byte 2,3,2,3,2,3,2,3,2,2,2,3,2,2,2,3,3,2,3,3,3,2,3,3,2,3,3,2,2,2,3,3,2,3,3,3,2,3,3,2,3

.align 4
@______________________________________________________________________________
.GetMapAddr: @ 楤 頥    ॣ r0
	push	{LR}
	adr	r0,map		@  
	pop	{PC}
@______________________________________________________________________________

.align 4
map:		@ ⥪  ( ன  ன)
.align 2
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3

@______________________________________________________________________________
.GetMapsAdr: @ 楤 頥  ᨢ   ॣ r0
	push	{LR}
	adr	r0,Level1	@  ᨢ (.  ࢮ )
	pop	{PC}
@______________________________________________________________________________

@ 㦥 ଠ    ᫥騩 ଠ
@ ६  宦  - 2 
@ ⢮  室  宦  - 2 
@ न    x,y - 2 
@ 砫 न  ᬮ  x,y - 2 
@ १ࢨ஢ - 12 

.equ MaxLevelNum,4	@ ᨬ  ஢(ࠢ  ஢)

.align 4
Level1:
.align 2   
.byte 110,0,35,0,3,5,14,12,0,0,0,0,0,0,0,0,0,0,0,0 @ <= 㦥
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
.byte 3,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,0,5,1,1,1,0,5,5,1,1,1,1,1,1,1,5,1,1,1,1,1,1,5,5,1,1,1,0,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,0,0,0,0,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,5,0,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,0,5,5,5,1,1,1,1,1,1,1,1,0,1,1,5,1,1,1,1,1,1,5,0,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,0,1,1,1,1,1,5,5,1,1,1,1,0,1,1,1,1,1,1,1,1,1,5,0,1,1,1,5,1,5,5,0,5,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,5,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,0,1,1,1,1,1,1,3
.byte 3,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,5,5,5,0,0,0,1,1,1,1,0,0,0,0,1,1,1,1,0,1,3
.byte 3,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,1,1,1,1,1,1,1,1,1,0,5,1,1,1,1,0,3
.byte 3,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,1,1,0,1,1,1,1,0,0,0,1,1,1,1,1,0,5,1,1,5,5,0,3
.byte 3,0,0,1,1,0,1,1,1,1,1,5,5,5,1,1,1,1,1,1,1,1,1,1,1,5,0,5,0,5,0,1,1,1,0,1,5,1,1,5,5,5,1,1,1,1,0,0,0,3
.byte 3,0,0,1,1,1,0,1,1,1,1,1,1,5,5,5,1,1,1,1,1,1,1,1,1,1,5,1,1,0,1,1,1,1,5,5,1,1,1,1,1,1,1,1,1,1,0,5,0,3
.byte 3,1,0,1,1,1,1,0,1,1,1,1,1,1,1,0,0,5,1,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,5,0,1,1,1,1,1,1,1,1,1,1,0,0,0,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,1,1,5,5,5,0,0,1,1,1,1,1,1,1,0,1,0,1,1,1,1,1,0,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,0,0,1,1,0,0,0,0,0,1,1,1,1,1,1,1,0,1,5,1,1,0,1,1,1,0,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,3
.byte 3,1,1,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
.byte 3,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,0,5,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,0,5,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,1,1,1,1,1,1,1,0,0,1,1,1,3
.byte 3,1,1,1,5,0,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,0,1,1,1,3
.byte 3,1,1,1,0,0,0,1,0,1,1,1,1,1,1,1,1,0,1,1,1,1,1,5,5,1,1,1,5,5,1,1,0,1,1,1,1,1,5,1,1,1,0,0,1,1,1,0,0,3
.byte 3,1,1,1,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,1,0,0,1,1,1,1,1,5,1,1,1,1,1,0,1,1,1,3
.byte 3,1,1,1,1,1,0,0,0,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,7,3
.byte 3,1,1,1,1,1,1,1,1,1,5,5,1,1,0,1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,0,0,1,1,1,1,1,1,1,1,1,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,3
.byte 3,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,0,0,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3

.align 4
Level2:
.align 2   
.byte 110,0,50,0,1,1,14,12,0,0,0,0,0,0,0,0,0,0,0,0 @ <= 㦥
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,5,5,5,1,1,1,1,1,3,1,5,1,1,1,3,1,1,1,1,1,1,1,0,0,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,5,1,1,3,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,0,0,0,0,0,0,5,1,1,1,1,3,1,1,1,5,1,3,1,1,1,1,0,1,1,1,0,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,5,5,5,0,5,1,1,1,3,1,1,5,1,1,3,1,1,1,5,5,5,1,1,1,3,1,1,5,0,5,0,5,0,5,0,5,0,5,0,5,0,5,1,3
.byte 3,1,1,1,1,1,1,5,5,1,0,5,1,1,3,1,5,1,1,1,3,3,3,3,3,3,3,3,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3
.byte 3,1,1,1,1,1,5,5,5,1,1,0,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,0,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,0,0,0,1,1,5,5,5,5,1,1,1,3,1,1,1,1,1,3,1,1,1,5,1,3,1,1,5,5,5,1,5,5,5,1,5,1,1,5,1,5,1,5,1,1,1,1,3
.byte 3,1,0,0,0,1,1,3,3,3,3,1,1,1,3,1,1,5,5,5,3,1,1,5,5,5,3,1,1,5,1,1,1,5,1,5,1,5,5,1,5,1,1,5,1,1,1,1,1,3
.byte 3,1,3,0,3,3,1,1,1,1,1,1,1,1,3,1,1,1,1,1,0,5,1,1,5,1,3,1,1,5,5,5,1,5,1,5,1,5,1,5,5,1,1,5,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,0,5,1,1,1,1,3,1,1,1,1,5,1,5,1,5,1,5,1,1,5,1,1,5,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,0,0,0,0,0,1,1,3,1,1,1,1,1,0,5,1,5,5,5,3,1,1,5,5,5,1,5,5,5,1,5,1,1,5,1,1,5,1,1,1,1,1,3
.byte 3,3,3,3,3,1,1,5,5,5,5,5,1,1,3,1,1,1,1,1,3,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,5,5,5,3,1,1,1,5,5,5,1,1,1,3,1,1,1,1,1,3,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,5,5,5,3,1,1,1,1,5,1,1,1,1,3,1,1,1,1,1,3,1,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,5,1,3,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,3,1,1,5,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,0,0,0,3,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,3,1,1,1,5,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,0,0,0,3,3,3,3,3,3,3,3,3,3,3,1,1,1,1,1,3,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,0,0,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,5,5,0,0,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,0,0,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,5,5,5,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,0,0,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3,1,5,5,5,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,5,5,5,5,1,1,1,1,1,3,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,7,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3

.align 4
Level3:
.align 2   
.byte 200,0,150,0,8,12,14,12,0,0,0,0,0,0,0,0,0,0,0,0 @ <= 㦥
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
.byte 3,0,5,0,5,5,5,5,0,5,0,5,0,0,0,5,5,5,5,0,0,0,5,5,5,5,5,5,5,5,5,0,5,0,5,5,0,5,5,5,5,5,5,0,0,0,0,0,5,3
.byte 3,0,0,0,5,5,5,5,0,0,0,0,0,5,5,5,5,5,5,5,5,0,0,0,5,5,5,0,0,0,5,5,5,5,5,5,0,0,5,5,5,0,5,5,0,5,5,5,5,3
.byte 3,5,5,5,5,0,5,5,5,5,5,5,5,0,0,5,5,5,0,0,5,0,5,5,5,5,5,5,5,5,5,0,5,5,5,5,0,0,0,0,0,5,5,5,5,5,5,5,5,3
.byte 3,5,0,5,5,0,5,5,5,5,5,5,0,5,5,0,5,0,5,5,5,0,0,0,5,5,0,0,0,5,5,5,0,5,5,0,0,5,5,5,0,5,5,5,5,5,0,5,0,3
.byte 3,5,0,0,5,5,5,0,5,5,5,0,0,5,5,0,0,0,5,0,5,5,5,0,0,0,5,5,5,5,5,5,0,0,0,5,5,5,5,0,5,5,5,5,5,0,5,5,5,3
.byte 3,5,0,5,5,0,0,5,0,5,5,5,1,5,0,5,5,5,5,5,5,5,0,0,0,0,5,5,5,5,5,5,5,5,5,5,5,5,0,5,5,5,5,5,0,5,5,5,5,3
.byte 3,0,0,5,5,5,0,0,0,0,5,5,0,0,5,5,5,5,5,0,0,5,0,0,0,0,0,0,0,0,5,5,0,0,5,5,5,5,5,0,0,0,5,5,0,5,5,5,5,3
.byte 3,5,5,5,5,5,5,5,5,5,5,5,5,0,0,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,0,0,0,0,0,5,5,5,0,0,5,5,0,0,0,0,0,0,0,3
.byte 3,5,5,5,3,3,3,3,3,3,3,3,1,3,3,3,3,3,3,3,5,0,5,5,5,5,5,5,5,3,3,3,3,3,3,3,3,1,3,3,3,3,3,3,3,5,5,5,5,3
.byte 3,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,5,5,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,5,0,5,3
.byte 3,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,0,5,5,0,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,3
.byte 3,5,5,5,3,4,4,7,4,4,4,4,4,4,4,4,4,4,4,3,5,5,0,5,5,0,5,5,1,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,0,0,5,3
.byte 3,0,5,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,5,5,0,5,0,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,3
.byte 3,0,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,0,0,5,5,0,0,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,5,0,5,3
.byte 3,5,0,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,0,0,5,5,5,0,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,0,0,5,3
.byte 3,0,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,0,1,0,0,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,0,1,0,3
.byte 3,0,5,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,0,0,0,0,0,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,3
.byte 3,5,0,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,0,0,5,0,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,3
.byte 3,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,5,0,0,0,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,3
.byte 3,5,0,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,0,0,5,5,5,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,5,5,5,3
.byte 3,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,0,5,5,3
.byte 3,5,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,0,5,3
.byte 3,5,5,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,0,0,0,4,4,1,1,1,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,0,5,5,3
.byte 3,0,5,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,1,5,5,5,1,1,1,1,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,0,5,5,5,3
.byte 3,0,0,0,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,1,1,1,1,1,1,1,1,5,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3,5,5,5,5,3
.byte 3,5,0,0,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,5,5,5,5,3
.byte 3,5,5,5,5,5,5,5,0,0,5,5,0,5,5,5,5,5,5,5,5,0,5,5,0,5,0,0,0,5,5,5,5,0,0,0,5,5,0,0,0,5,5,5,5,5,5,5,5,3
.byte 3,5,5,5,5,5,5,0,5,5,5,5,5,5,5,0,0,5,5,5,0,0,0,5,5,5,5,0,5,5,5,0,0,0,0,5,0,0,5,0,0,0,0,0,0,0,0,0,0,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3

.align 4
Level4:
.align 2   
.byte 205,0,80,0,20,11,14,12,0,0,0,0,0,0,0,0,0,0,0,0 @ <= 㦥
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
.byte 3,5,5,5,1,1,3,1,0,0,5,0,3,1,1,1,1,5,0,1,1,5,5,1,1,3,0,5,1,0,1,1,3,1,1,1,1,0,0,3,1,1,1,1,3,1,1,5,5,3
.byte 3,0,1,5,5,5,3,5,5,1,1,5,3,1,5,1,5,1,0,1,1,1,1,1,1,3,1,1,1,0,1,1,3,1,0,1,1,1,1,3,1,1,1,1,3,1,5,1,0,3
.byte 3,1,1,0,0,1,1,1,1,1,1,1,1,1,1,5,1,1,0,1,1,1,1,5,5,1,1,0,0,1,1,1,1,1,1,0,0,1,1,1,1,5,5,5,1,1,1,1,0,3
.byte 3,1,1,1,0,1,3,1,0,0,1,1,3,0,1,1,5,1,1,1,1,1,1,1,1,3,1,1,0,0,0,1,3,0,0,1,1,0,1,3,1,0,0,0,3,0,0,0,1,3
.byte 3,1,1,1,1,1,3,1,1,1,1,1,3,1,1,1,1,5,1,5,5,5,1,1,1,3,1,1,1,1,1,1,3,1,1,1,1,1,1,3,1,5,5,5,3,1,1,0,0,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,3,3,3,3,3,3,3
.byte 3,1,1,1,1,1,3,1,1,1,5,5,3,1,5,5,5,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,3,1,1,5,5,5,5,3,1,1,1,1,3,1,1,1,1,3
.byte 3,1,1,1,1,1,3,1,5,1,1,1,3,1,1,1,1,1,1,1,1,0,1,1,1,3,1,1,1,1,1,1,3,1,0,1,1,1,1,3,1,1,1,1,3,1,1,1,1,3
.byte 3,0,1,1,1,1,1,1,1,5,1,1,1,5,5,5,1,1,1,5,5,0,0,1,1,1,1,5,5,5,5,1,1,1,1,0,1,5,5,1,1,1,1,1,1,1,1,1,1,3
.byte 3,1,0,0,0,1,3,5,5,1,5,1,3,1,1,1,1,1,1,1,1,0,0,1,1,3,1,0,0,1,1,0,3,1,1,1,1,1,1,3,1,1,1,1,3,1,1,1,1,3
.byte 3,1,1,0,0,1,3,1,1,1,5,1,3,1,1,1,1,1,1,1,1,5,5,1,1,3,1,0,0,0,0,1,3,5,5,5,5,5,5,3,1,5,5,1,3,1,1,1,1,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
.byte 3,1,1,0,0,0,3,1,1,1,1,1,3,4,4,4,4,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,3,1,0,5,0,1,1,3,1,1,1,1,3,1,5,1,1,3
.byte 3,0,0,1,1,0,3,1,0,0,1,1,3,4,4,4,4,1,1,1,1,1,1,1,1,3,1,5,5,5,1,1,3,1,5,5,5,1,1,3,1,1,1,1,3,5,5,5,1,3
.byte 3,1,1,1,1,1,1,1,1,5,5,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,1,1,1,1,1,1,1,1,1,1,5,1,1,3
.byte 3,1,1,1,1,0,3,1,1,1,1,1,3,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,3,1,1,5,1,1,1,3,1,1,1,1,3,1,5,1,1,3
.byte 3,1,1,0,0,1,3,4,4,0,0,1,3,1,1,1,1,1,1,1,1,1,1,1,1,3,1,1,1,1,1,1,3,1,1,1,1,1,1,3,1,1,1,1,3,1,1,1,1,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,1,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,1,3
.byte 3,5,5,5,5,5,3,1,5,1,1,5,3,1,1,1,0,3,1,1,3,1,1,1,5,3,5,5,5,5,5,5,3,1,1,1,1,1,1,3,5,5,5,5,3,0,0,1,1,3
.byte 3,0,0,0,0,0,3,1,1,5,1,1,3,0,1,1,1,3,1,1,3,1,1,5,0,3,5,5,0,5,0,5,3,1,1,1,1,1,1,3,5,5,5,5,3,1,1,1,1,3
.byte 3,5,5,5,5,5,3,1,1,1,5,1,3,1,0,1,1,3,1,1,3,1,5,0,0,3,5,0,5,5,5,5,3,1,1,1,1,1,1,3,0,5,5,5,3,5,5,0,0,3
.byte 3,1,1,1,1,1,3,5,0,0,5,5,3,1,1,0,1,3,1,1,3,5,0,0,0,3,5,5,0,5,5,5,3,1,1,1,1,1,1,3,0,0,5,5,3,1,1,5,1,3
.byte 3,1,1,1,1,1,3,1,1,1,0,0,3,1,0,1,1,3,1,1,3,1,5,5,5,3,5,5,5,0,5,5,3,1,1,1,1,1,1,3,1,0,0,5,3,5,5,1,1,3
.byte 3,1,1,1,1,1,3,1,1,1,0,1,3,0,1,1,0,3,1,1,3,1,1,1,1,3,5,5,5,5,0,5,3,1,1,1,1,1,1,3,1,1,0,0,3,1,1,5,1,3
.byte 3,7,1,1,1,1,3,0,0,0,1,1,3,1,0,0,1,3,1,1,3,0,1,1,1,3,5,0,5,5,5,5,3,1,1,1,1,1,1,3,1,1,1,0,3,1,1,0,0,3
.byte 3,1,1,1,1,1,3,1,1,1,1,1,3,1,1,1,1,3,1,1,3,1,0,5,0,3,5,5,5,5,0,5,3,1,1,1,1,1,1,3,1,1,1,1,3,5,5,0,0,3
.byte 3,1,1,1,1,1,3,1,1,1,1,1,3,1,1,1,1,3,1,1,3,1,1,0,1,3,5,5,5,5,5,5,3,1,1,1,1,1,1,3,1,1,1,1,3,1,1,1,1,3
.byte 3,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,5,5,5,5,5,5,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,3
.byte 3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
